TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Buff)

-- TODO: Roll is slower and shorter than in WoW, fix sometime

--TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll.ROLLDURATION=1000
TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll.ROLLDURATION=800
	--slow roll, feels okay but doesn't feel like WoW: 1000 duration, 200 delay, 2.0 speed, animation ends -250
	--fast roll, feels slow to start: 1000 duration, 300 delay, 2.75x speed, animation ends -250
	--1000 duration, 100 delay, 2.75x speed, animation ends 0

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll:setCustomBuffInfo(combat)
	TRAININGGROUNDS_Buff.setCustomBuffInfo(self,combat)
	self.duration=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll.ROLLDURATION
	self.visibletoplayer=false
	

	self.requirestarget=false
	self.range=nil
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll:OnBuffStart()

	
	--TODO: if player is inputting any movement direction, roll in that direction instead
	--TODO: slight change to player's midair speed when roll starts

	self.combat.character.lockfacingendtick=self.starttime+self.duration
	self.combat.character.lockmovementendtick=self.starttime+self.duration
	--print(self.starttime+self.duration)
	
	
	-- if character is moving in a direction, we want to be sure we're facing in that direction (normally takes a second or two to turn around
		-- * however, at the moment, there's no control to jump forward and roll backward, and that messes up appearances
		-- until we have a way to start a roll in midair in a different direction from the way we're moving, just roll the way we're facing in midair and ignore movement
	if(self.combat.character.z<=0 and (self.combat.character.xspeed~=0 or self.combat.character.yspeed~=0))then
	--if((self.combat.character.xspeed~=0 or self.combat.character.yspeed~=0))then
		self.combat.character.currentfacing=math.atan2(self.combat.character.xspeed,-self.combat.character.yspeed)
		--print(self.combat.character.currentfacing)
		self.combat.character:SetAdjustedFacing(self.combat.character.currentfacing)
	end
	
	
	self.rollxx=math.sin(self.combat.character.currentfacing)
	self.rollyy=-math.cos(self.combat.character.currentfacing)	
	
	if(self.combat.character.z>0)then
		
	end
	
	--self.combat.character.attackanimation=664
	--self.combat.character.attackanimationendtick=self.starttime+500
	--self.combat.character:changeFrameAnimation(self.combat.character.attackanimation)
	self.combat.character:SetAnimationByIndex(664,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,500)

	--print(self.combat.character.attackanimationendtick)
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll:OnReapply(existingbuff, executiontime)
	TRAININGGROUNDS_Buff.OnReapply(self, existingbuff, executiontime)
	self.combat.character.lockfacingendtick=executiontime+self.duration
	self.combat.character.lockmovementendtick=executiontime+self.duration
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll:OnBuffEnd()	
	--self.combat.character.attackanimation=668
	--self.combat.character.attackanimationendtick=self.combat.character.environment.currenttime+500	
	--self.combat.character:changeFrameAnimation(self.combat.character.attackanimation)	
	
	self.combat.character:SetAnimationByIndex(668,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,500,false,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE,150)
	--self.combat.character:SetAnimationByIndex(668,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,500)
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll:step()
	--if(self.combat.character.environment.currenttime>=self.starttime+200)then
	--if(self.combat.character.environment.currenttime>=self.starttime+300)then
	if(self.combat.character.environment.currenttime>=self.starttime+100)then
		if(self.combat.character.z<=0)then
			--local speed=2
			local speed=2.75
			-- TODO: change "currentfacing" so it works with standard radians
			--	(SetFacing remains locked to WoW radians, nothing we can do about that)
			self.combat.character.xspeed=self.rollxx*speed*TRAININGGROUNDS_Game.TEMP_MOVESPEED
			self.combat.character.yspeed=self.rollyy*speed*TRAININGGROUNDS_Game.TEMP_MOVESPEED
		end		
	end
	-- if(self.combat.character.z<=0)then
		-- local speed=2.75
		-- if(self.combat.character.environment.currenttime<self.starttime+200)then
			-- speed=1
		-- end
		-- -- TODO: change "currentfacing" so it works with standard radians
		-- --	(SetFacing remains locked to WoW radians, nothing we can do about that)
		-- self.combat.character.xspeed=self.rollxx*speed*TRAININGGROUNDS_Game.TEMP_MOVESPEED
		-- self.combat.character.yspeed=self.rollyy*speed*TRAININGGROUNDS_Game.TEMP_MOVESPEED
	-- end

	
	-- if(self.combat.character.environment.currenttime>self.expirytime-250)then
		-- self.combat.character.attackanimation=668
		-- self.combat.character.attackanimationendtick=self.combat.character.environment.currenttime+500
		-- self.combat.character:changeFrameAnimation(self.combat.character.attackanimation)
	-- end	
end