TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Defend"
	self.shortspellname="DF"
	self.icon="Interface\\Icons\\ability_warrior_shieldreflection"
	
	--self.animationname="ChiBurst"
	
	self.defaultcooldown=10000+500
	--self.defaultcooldown=250+3000 --!!!
	--TODO: cooldown is 2500, not 10000+ -- can cast defend immediately if broken by CC
		-- (probably make it a channeled spell, but set channel as not-visible)
	
	
	self.casted=true
	self.casttime=2500
	--self.casttime=250	--!!!
	self.castablewhilemoving=false
	-- self.channeled=true
	-- self.channelduration=10000	
	
	self.damage=nil
	
	self.range=nil
	
	self.requirestarget=false
	
	
		
end


function TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend:OnCastStart(starttime)
	TRAININGGROUNDS_Spell.OnCastStart(self,starttime)
	local animationindex=29		-- apparently not actually 29, but as close as we can get
	--TODO: stuns can override the guard animation
	
	self.combat.character:SetAnimationByIndex(animationindex,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,12500)


	-- guardian will only try to turn while cast is in progress (not channel)
	self.combat.character.targetfacing=math.random()*math.pi*2
	-- --CB doesn't require facing, but if player has a target, snap to it
	-- if(self.combat.target~=nil)then
		-- self.combat.character.snapfacingtarget=self.combat.target
		-- --TODO: not "500"
		-- self.combat.character.snapfacingendtick=starttime+500
	-- end
end

function TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend:ApplySpellAnimation(executespelltick)
	-- do nothing; CB spell animation starts on cast start
end

function TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	--apply Defend buff
	
	local defend=TRAININGGROUNDS_Buff_Enemy_ProvingGrounds_Defend.new()
	defend:setup(self.combat,executespelltick)
end
