TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FlyingSerpentKick = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

--TODO: stance 0 after using FSK w/o slam attack

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FlyingSerpentKick:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Flying Serpent Kick"
	self.shortspellname="FSK"

	self.defaultcooldown=25000
	
	self.animationsequence=nil
	
	self.range=nil
	self.requirestarget=false
	self.usesgcd=true

	--!!!
	--self.queueable=false
	

	self.damage=nil
	self.aoedamage=53
	
	self.icon="Interface\\Icons\\ability_monk_flyingdragonkick"
end



function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FlyingSerpentKick:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	
	local buff
	buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick.new()
	buff:setup(self.combat,executespelltick)	
end

--TODO: do something better
function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FlyingSerpentKick:executeDespiteCooldown(executespelltick)	
	local fsk=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick)
	if(fsk~=nil)then
		self.combat.character:SetAnimationByIndex(706,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,750,false,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE,300)
		fsk:SelfDispel()
		--TODO: as written, FSK and Roll break loss of control effects...
		self.combat.character.lockfacingendtick=executespelltick
		self.combat.character.lockmovementendtick=executespelltick
		
		
		local minradius=1
		--local maxradius=350
		local maxradius=300
		
		local objlist=self.combat.character.environment:PointCircleCollisionList(self.combat.character.x, self.combat.character.y, minradius, maxradius)
		local wowlist={}
		local i
		for i=1,#objlist,1 do
			local obj=objlist[i]
			if(obj.combat~=nil)then
				--TODO: not isa
				if(obj:isa(TRAININGGROUNDS_Enemy))then		
					tinsert(wowlist,obj)
				end
			end
		end
		
		
		for i=1,#wowlist,1 do		
			local obj=wowlist[i]
			self.combat:ApplyDamageToEnemy(self.aoedamage,obj)			
		end
		
		return true
	end
	return false
end