TRAININGGROUNDS_Environment_WarningMenu = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Environment)

function TRAININGGROUNDS_Environment_WarningMenu:setup(game,gameframe)
	TRAININGGROUNDS_Environment.setup(self,game,gameframe)
	
	self.dead=false
	
	self.camera.objectanchor="TOPLEFT"
	
	
	
	local textbox=TRAININGGROUNDS_TemporaryTextField.new()
	textbox:setup(self)
	--TODO: screenwidth instead of 640
	textbox.frame:SetWidth(640);textbox.frame:SetHeight(300)	
	textbox.frame.fontstring:SetJustifyH("CENTER")		
	textbox.frame.fontstring:SetText("HEALTH AND SAFETY PRECAUTIONS"..string.char(13)..
										string.char(13)..
										"TrainingGrounds is played using the keyboard and mouse."..string.char(13)..
										"While playing, you will be |cFFFFFF00unable to control your character|cFFFFFFFF in World of Warcraft."..string.char(13)..
										"Please make sure your character is in a |cFFFFFF00safe place|cFFFFFFFF before you begin.")
	textbox.x=0
	textbox.y=0
	textbox:draw()
	textbox.frame:Show()	
	textbox.xspeed=0
	textbox.yspeed=0	
	textbox.expirytime=nil
	--print("Textbox: ",textbox)
	

	-- local textbox=TRAININGGROUNDS_TemporaryTextField.new()
	-- textbox:setup(self)
	-- textbox.frame:SetWidth(640);textbox.frame:SetHeight(100)	
	-- textbox.frame.fontstring:SetJustifyH("CENTER")		
	-- textbox.frame.fontstring:SetText("To close TrainingGrounds after the game begins, press and hold the Esc key.")
	-- textbox.x=0
	-- textbox.y=-375
	-- textbox:draw()
	-- textbox.frame:Show()	
	-- textbox.xspeed=0
	-- textbox.yspeed=0	
	-- textbox.expirytime=nil
	
	

	--print("Menubutton 1: ",menubutton)
	
	local menubutton2=TRAININGGROUNDS_MenuButton.new()
	--local menubutton=TRAININGGROUNDS_TemporaryTextField.new()
	menubutton2:setup(self)	
	menubutton2.x=120
	menubutton2.y=-308
	menubutton2:SetText("Cancel")
	menubutton2.frame:SetScript("OnClick",function() _TRAININGGROUNDS:Shutdown() end)
	--print("Menubutton 2: ",menubutton)

	
	local menubutton=TRAININGGROUNDS_MenuButton.new()
	--local menubutton=TRAININGGROUNDS_TemporaryTextField.new()
	menubutton:setup(self)	
	menubutton.x=120
	menubutton.y=-228
	menubutton:SetText("Start game")
	menubutton.frame:SetScript("OnClick",function() 
												menubutton.frame:EnableMouse(false)
												menubutton2.frame:EnableMouse(false)												
												TRAININGGROUNDS_Environment_WarningMenu_AcceptWarning(self) 
											end)
	
end


function TRAININGGROUNDS_Environment_WarningMenu:step(elapsed)
	TRAININGGROUNDS_Environment.step(self,elapsed)
	if(self.game.keys.esc.pressed==true)then
		_TRAININGGROUNDS:die()
	end
	-- if(self.dead~=true)then
		-- TRAININGGROUNDS_Environment.step(self,elapsed)
		-- if(TRAININGGROUNDS_VARS.acceptedwarning==true)then
			-- self.dead=true
			-- self:Cleanup()			
		-- end
	-- end
end



-- underscore instead of colon
function TRAININGGROUNDS_Environment_WarningMenu_AcceptWarning(warningmenu)
	--print("TRAININGGROUNDS_Environment_WarningMenu_AcceptWarning")
	TRAININGGROUNDS_VARS.acceptedwarning=true
	
	--warningmenu.game:ShowFirstMenuAfterWarning()
	warningmenu.game:SetEnvironmentTransition(function()
										warningmenu:Cleanup()
										warningmenu.frame:Hide()										
										warningmenu.game:ShowFirstMenuAfterWarning()
									end)

end