TRAININGGROUNDS_BorderGraphic = {}
TRAININGGROUNDS_BorderGraphic.__index = TRAININGGROUNDS_BorderGraphic

function TRAININGGROUNDS_BorderGraphic.new()
	local self=setmetatable({}, TRAININGGROUNDS_BorderGraphic)	
		
	return self
end

function TRAININGGROUNDS_BorderGraphic:setup(parentframe)
	self.parent=parentframe	
	self.top=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.top:SetParent(parentframe)
	self.top:SetWidth(parentframe:GetWidth())
	self.top:SetHeight(2)
	self.top:SetPoint("TOPLEFT",parentframe,"TOPLEFT",0,0)
	self.top.texture:SetTexture(1,1,1,1)
	self.top:Show()
	self.top.texture:Show()
	self.top.tag="Border for "..tostring(parentframe.tag)
	
	self.bottom=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.bottom:SetParent(parentframe)
	self.bottom:SetWidth(parentframe:GetWidth())
	self.bottom:SetHeight(2)
	self.bottom:SetPoint("BOTTOMLEFT",parentframe,"BOTTOMLEFT",0,0)
	self.bottom.texture:SetTexture(1,1,1,1)
	self.bottom:Show()
	self.bottom.texture:Show()	
	self.bottom.tag="Border for "..tostring(parentframe.tag)
	
	self.left=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.left:SetParent(parentframe)
	self.left:SetWidth(2)
	self.left:SetHeight(parentframe:GetHeight())
	self.left:SetPoint("TOPLEFT",parentframe,"TOPLEFT",0,0)
	self.left.texture:SetTexture(1,1,1,1)
	self.left:Show()
	self.left.texture:Show()
	self.left.tag="Border for "..tostring(parentframe.tag)
	
	self.right=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.right:SetParent(parentframe)
	self.right:SetWidth(2)
	self.right:SetHeight(parentframe:GetHeight())
	self.right:SetPoint("TOPRIGHT",parentframe,"TOPRIGHT",0,0)
	self.right.texture:SetTexture(1,1,1,1)
	self.right:Show()
	self.right.texture:Show()	
	self.right.tag="Border for "..tostring(parentframe.tag)
end

function TRAININGGROUNDS_BorderGraphic:Redraw(parentframe)
	self.top:SetWidth(parentframe:GetWidth())
	self.bottom:SetWidth(parentframe:GetWidth())
	self.left:SetHeight(parentframe:GetHeight())
	self.right:SetHeight(parentframe:GetHeight())
end

function TRAININGGROUNDS_BorderGraphic:Cleanup()
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.top)
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.bottom)
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.left)
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.right)	
end