-- Debug menu.  Simplified version of choose class menu.

TRAININGGROUNDS_MenuController_ClassModelAlignment = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_MenuController)

function TRAININGGROUNDS_MenuController_ClassModelAlignment:setup(environment)
	TRAININGGROUNDS_MenuController.setup(self,environment)

	environment.camera.zoom=0.5

	local fakeplayerclasses = {
							TRAININGGROUNDS_FakePlayerCharacter_Warrior,
							TRAININGGROUNDS_FakePlayerCharacter_Paladin,
							TRAININGGROUNDS_FakePlayerCharacter_Hunter,
							TRAININGGROUNDS_FakePlayerCharacter_Rogue,
							TRAININGGROUNDS_FakePlayerCharacter_Priest,
							TRAININGGROUNDS_FakePlayerCharacter_Shaman,														
							TRAININGGROUNDS_FakePlayerCharacter_Mage,							
							TRAININGGROUNDS_FakePlayerCharacter_Warlock,
							TRAININGGROUNDS_FakePlayerCharacter_Monk,
							TRAININGGROUNDS_FakePlayerCharacter_Druid,
							TRAININGGROUNDS_FakePlayerCharacter_DeathKnight,
							TRAININGGROUNDS_FakePlayerCharacter_DemonHunter
								}
								
	local racetable={}
	for i,v in pairs(TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable) do
		tinsert(racetable,v)
	end

								
	local x,y,race,sex=0,0,1,0
	-- -- use with normal game screen
	-- for i=0,25,1 do
		-- local fake=TRAININGGROUNDS_FakePlayerCharacter_DemonHunter.new()
		-- fake:setup(environment,racetable[race],sex)
		-- fake.x=75+x*112
		-- fake.y=-250+y*-180
		-- sex=sex+1
		-- if(sex>1) then sex=0;race=race+1 end		
		-- x=x+1
		-- if(x>=10)then x=0;y=y+1 end
	-- end	
	
	-- use with extra wide game screen
	for i=0,25,1 do
		local fake=TRAININGGROUNDS_FakePlayerCharacter_DemonHunter.new()
		--local fake=TRAININGGROUNDS_FakePlayerCharacter.new()
		fake:setup(environment,racetable[race],sex)
		fake.x=75+x*85
		fake.y=-250+y*-180
		sex=sex+1
		if(sex>1) then sex=0;race=race+1 end		
		x=x+1
		if(x>=26)then x=0;y=y+1 end
	end		
	
end