TRAININGGROUNDS_ScenarioController_Tutorial = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_ScenarioController)

function TRAININGGROUNDS_ScenarioController_Tutorial:SetCustomInfo()
	TRAININGGROUNDS_ScenarioController.SetCustomInfo(self)
	
	self.ysortable=false
	
	self.states={}
	
	local i=0
	i=i+1;self.states.SETUP=i
	i=i+1;self.states.WAIT=i
	i=i+1;self.states.WELCOME=i
	i=i+1;self.states.EARLYBUILDWARNING=i	
	i=i+1;self.states.CLEARBEFORECHECKCONTROLS=i
	i=i+1;self.states.CHECKCONTROLS=i
	i=i+1;self.states.SPAWNPLAYER=i	
	i=i+1;self.states.WAVE=i
	i=i+1;self.states.SPAWNCRITTERS=i
	i=i+1;self.states.WASD=i
	i=i+1;self.states.MOVEMENTWORKS=i
	i=i+1;self.states.SPAWNRAT=i
	i=i+1;self.states.LMBTARGET=i
	i=i+1;self.states.PRESS1ATTACK=i
	i=i+1;self.states.ATTACKWORKS=i
	i=i+1;self.states.UNLOCKCAMERA=i
	i=i+1;self.states.MOUSEWHEELZOOM=i
	i=i+1;self.states.PGUPPGDNZOOM=i
	i=i+1;self.states.WAITFORZOOM=i
	i=i+1;self.states.WAITFORRABBIT=i
	i=i+1;self.states.SPEEDBOOST=i
	i=i+1;self.states.PRESS8ROLL=i
	i=i+1;self.states.WAITFORSPEEDBOOST=i
	i=i+1;self.states.WAITFORRABBITCLEAR=i
	i=i+1;self.states.WAITFORALLCLEAR=i
	i=i+1;self.states.WAITBEFORESETUPPHASE2=i
	i=i+1;self.states.SETUPPHASE2=i
	i=i+1;self.states.BIGVIRMENROAR=i
	i=i+1;self.states.KNOCKDOWN=i
	i=i+1;self.states.SPAWNMINIONS=i
	i=i+1;self.states.TIGERPALM=i
	i=i+1;self.states.WAITFORTIGERPALM=i
	i=i+1;self.states.STRIKEOFTHEWINDLORD=i
	i=i+1;self.states.WAITFORSTRIKEOFTHEWINDLORD=i
	i=i+1;self.states.FISTSOFFURY=i
	i=i+1;self.states.WAITFORFISTSOFFURY=i	
	i=i+1;self.states.HIGHPRIORITY=i
	i=i+1;self.states.RISINGSUNKICK=i
	i=i+1;self.states.WAITFORRISINGSUNKICK=i
	i=i+1;self.states.MEDIUMPRIORITY=i
	i=i+1;self.states.COREROTATION=i
	i=i+1;self.states.ATTHISPOINT=i
	i=i+1;self.states.ADVANCEDTECHNIQUES=i
	i=i+1;self.states.BLACKOUTKICK=i	
	i=i+1;self.states.WAITFORBLACKOUTKICK=i
	i=i+1;self.states.SPINNINGCRANEKICK=i
	i=i+1;self.states.WAITFORSPINNINGCRANEKICK=i
	i=i+1;self.states.LOWPRIORITY=i
	i=i+1;self.states.TIGEREYEBREW=i
	i=i+1;self.states.WAITFORTIGEREYEBREW=i
	i=i+1;self.states.ROLL=i
	i=i+1;self.states.FLYINGSERPENTKICK=i
	i=i+1;self.states.WAITFORFLYINGSERPENTKICK=i
	i=i+1;self.states.SUMMARIZE=i
	i=i+1;self.states.RUNAWAY=i
	i=i+1;self.states.TOUCHOFDEATH=i
	i=i+1;self.states.WAITFORTOUCHOFDEATH=i
	i=i+1;self.states.WAITFORVIRMENCLEAR=i	
	i=i+1;self.states.CONCLUSION=i
	i=i+1;self.states.UNLOCK=i
	i=i+1;self.states.END=i

	self.state=0
	self.nextstate=self.states.SETUP
	self.statetimer=0
	
	self.critters={}
	self.rabbit=nil
	self.bigvirmen=nil
	self.virmen={}
	self.virmenrespawntime={}
	self.nextminionspawntime=0
	self.nextminionspawnframecount=0
	
	
end

function TRAININGGROUNDS_ScenarioController_Tutorial:step(elapsed)
	TRAININGGROUNDS_ScenarioController.step(self,elapsed)
	
	local currenttime=self.environment.currenttime
	

	
	if(self.statetimer~=nil)then
		if(self.mostrecenttypewriter==nil
			or (self.mostrecenttypewriter.letterindex>=#self.mostrecenttypewriter.targetmessage)
			or self.mostrecenttypewriter.dontlock==true
			or self.mostrecenttypewriter.dead==true)then
			self.statetimer=self.statetimer-elapsed*1000
		end
		--print(self.statetimer)
		if(self.statetimer<=0)then	
			self.statetimer=0
			self.state=self.nextstate

			if(self.state==self.states.SETUP)then
				local arenaborder=TRAININGGROUNDS_ArenaBorder.new()
				arenaborder:setup(self.environment)	
				arenaborder.frame.framelevel=1
				arenaborder.frame:SetFrameLevel(arenaborder.frame.framelevel)
				self.environment:ResetCamera()
				self.statetimer=0
				self.nextstate=self.states.WAIT	
			elseif(self.state==self.states.WAIT)then							
				self.statetimer=1000
				self.nextstate=self.states.WELCOME
			elseif(self.state==self.states.WELCOME)then			
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Welcome to TrainingGrounds.")
				self.statetimer=2000
				self.nextstate=self.states.EARLYBUILDWARNING				
			elseif(self.state==self.states.EARLYBUILDWARNING)then		
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"This is an early preview build.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Call it a proof of concept.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"A lot of things are broken or missing.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"If you're reading this, the game hasn't crashed yet.  That's good...");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=3					
				self.statetimer=2000
				self.nextstate=self.states.CLEARBEFORECHECKCONTROLS
			elseif(self.state==self.states.CLEARBEFORECHECKCONTROLS)then		
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				self.statetimer=0
				self.nextstate=self.states.CHECKCONTROLS
			elseif(self.state==self.states.CHECKCONTROLS)then						
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Let's check if the basic controls work.")
				self.statetimer=0
				self.nextstate=self.states.SPAWNPLAYER
			elseif(self.state==self.states.SPAWNPLAYER)then				
				self.player=TRAININGGROUNDS_PlayerCharacter.new()
				self.environment.player=self.player
				self.player:setup(self.environment)
				self.player.x=0;self.player.y=0
				self.player.z=300
				self.player:SetAdjustedFacing(0)
				self.player.combat=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.new()
				self.player.combat:setup(self.player)
				self.player.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP)
				self.player.combat:CreateTutorialSpellButtons(1)				
				self.player.combat:CreateVisibleFrames()	--channelbar
				local buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new()
				buff:setup(self.player.combat,currenttime); self.player.modelframe:SetAlpha(0)				
				if(_TRAININGGROUNDS.debug_autoscenario~=true)then				
					self.player.lockmovementendtick=currenttime+TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION
					self.player.lockfacingendtick=currenttime+TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION					
				end
				
				self.player.crittercount=6
				--TODO: delay only as long as wave animation lasts
				--self.statetimer=TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION-2500										
				self.statetimer=TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION-2500
				self.nextstate=self.states.WAVE
			elseif(self.state==self.states.WAVE)then
				self.player:SetAnimationByName("Wave")
				self.statetimer=2500
				self.nextstate=self.states.WASD							
			elseif(self.state==self.states.WASD)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"To move, use |cFFFFFF00WASD|cFFFFFFFF on the keyboard")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"or press |cFFFFFF00LEFT+RIGHT MOUSE BUTTONS|cFFFFFFFF together.")
				self.statetimer=nil
				self.nextstate=self.states.MOVEMENTWORKS				
			elseif(self.state==self.states.MOVEMENTWORKS)then				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Basic movement controls seem to be in order.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Sending in an NPC...")
				self.statetimer=1
				self.nextstate=self.states.SPAWNRAT
			elseif(self.state==self.states.SPAWNRAT)then	
				local critter=TRAININGGROUNDS_Enemy_Tutorial_Critter_Rat.new()
				--critter:setup(self.environment);critter.x=700;critter.y=0;critter.airadius=critter.x
				critter:setup(self.environment);critter.x=-500;critter.y=0;critter.airadius=math.abs(critter.x);critter.minairadius=150
				tinsert(self.critters,critter)			
				self.statetimer=3000
				self.nextstate=self.states.LMBTARGET											
			elseif(self.state==self.states.LMBTARGET)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00LEFT-CLICK|cFFFFFFFF NPCs to target them.")				
				self.statetimer=nil
				self.nextstate=self.states.PRESS1ATTACK
			elseif(self.state==self.states.PRESS1ATTACK)then				
				self.environment.player.combat:CreateTutorialSpellButtons(2)
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Press |cFFFFFF001|cFFFFFFFF to attack.")
				self.statetimer=nil
				self.nextstate=self.states.ATTACKWORKS
			elseif(self.nextstate==self.states.ATTACKWORKS)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Good, that still works.")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Unlocking the camera...")
				self.statetimer=3000
				self.nextstate=self.states.UNLOCKCAMERA
			elseif(self.state==self.states.UNLOCKCAMERA)then
				local critter=TRAININGGROUNDS_Enemy_Tutorial_Critter_Rabbit.new()
				critter:setup(self.environment);critter.x=0;critter.y=800;critter.airadius=critter.y
				tinsert(self.critters,critter)
				self.rabbit=critter			
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")				
				self.environment.camera:ChangeFocus(self.player)
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"The camera is now following you.")
				self.statetimer=1
				self.nextstate=self.states.MOUSEWHEELZOOM
			elseif(self.state==self.states.MOUSEWHEELZOOM)then			
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Use |cFFFFFF00SCROLL WHEEL|cFFFFFFFF to zoom in and out.")				
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"You can also use the |cFFFFFF00HOME|cFFFFFFFF and |cFFFFFF00END|cFFFFFFFF keys.")
				self.statetimer=2000
				self.nextstate=self.states.PGUPPGDNZOOM
			elseif(self.state==self.states.PGUPPGDNZOOM)then				
				--skip, sort of
				--self.statetimer=3000
				self.nextstate=self.states.WAITFORZOOM
			elseif(self.state==self.states.WAITFORZOOM)then
				self.statetimer=nil
				self.nextstate=self.states.WAITFORRABBIT
			elseif(self.state==self.states.WAITFORRABBIT)then				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")			
				self.statetimer=nil
				self.nextstate=self.states.SPEEDBOOST				
			elseif(self.state==self.states.SPEEDBOOST)then
				self.environment.player.combat:CreateTutorialSpellButtons(3)
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"To move quickly,")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"press |cFFFFFF00R|cFFFFFFFF to use your temporary speed boost,")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"or press |cFFFFFF00MIDDLE MOUSE BUTTON|cFFFFFFFF to roll.")
				self.statetimer=3000
				self.nextstate=self.states.PRESS8ROLL
			elseif(self.state==self.states.PRESS8ROLL)then
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(You can also roll by pressing |cFFFFFF008|cFFFFFFFF.)")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
				tm:CenterInUI(); tm.speedmultiplier=3	
				self.statetimer=2000
				self.nextstate=self.states.WAITFORRABBITCLEAR
			elseif(self.state==self.states.WAITFORRABBITCLEAR)then
				self.statetimer=nil
				self.nextstate=self.states.WAITFORALLCLEAR
			elseif(self.state==self.states.WAITFORALLCLEAR)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")			
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"OK.  Moving on...")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				self.statetimer=nil
				self.nextstate=self.states.WAITBEFORESETUPPHASE2
			elseif(self.state==self.states.WAITBEFORESETUPPHASE2)then
				-- skip
				self.statetimer=1
				self.nextstate=self.states.SETUPPHASE2
			elseif(self.state==self.states.SETUPPHASE2)then
			
				self.player.combat:CreateTutorialSpellButtons(4)
			
				local i
				for i=1,#self.critters,1 do
					self.critters[i]:die()
				end
				self.critters={}
				self.rabbit=nil				
				
				local bigvirmen=TRAININGGROUNDS_Enemy_Tutorial_HugeVirmen.new()
				bigvirmen:setup(self.environment);bigvirmen.x=0;bigvirmen.y=0;
				bigvirmen.combat=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.new();bigvirmen.combat:setup(bigvirmen)
				local buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new()
				buff:setup(bigvirmen.combat,currenttime);	bigvirmen.modelframe:SetAlpha(0)
				self.bigvirmen=bigvirmen
				self.bigvirmen.z=300
				self.environment.camera:ChangeFocus(bigvirmen)
				self.remembertargetzoom=self.environment.camera.targetzoom
				self.environment.camera.targetzoom=1
				
				--virmen roar: 55
				-- duration: 1500 (but we use 1200)
				
				--TODO: this line is related to the disappearing virmen problem; current priority!
				--self.player.combat:CreateTutorialSpellButtons(4)
				
				self.statetimer=nil
				self.nextstate=self.states.KNOCKDOWN	
			elseif(self.state==self.states.KNOCKDOWN)then
				--TODO: this breaks if player is at exactly (0,0)
				local facingangle=math.atan2(self.player.x,-self.player.y)+math.pi
				self.player.currentfacing=facingangle
				self.player.modelframe:SetFacing(facingangle)
				self.player.lockmovementendtick=currenttime+5000
				self.player.lockfacingendtick=currenttime+5000
				local moveangle=math.atan2(self.player.y,self.player.x)
				self.player.xspeed=math.cos(moveangle)*500
				self.player.yspeed=math.sin(moveangle)*500
				--TODO: the midair knockdown looks awkward for a few character models
				self.player.zspeed=500
				self.player:SetAnimationByName("Knockdown")
				self.nextstate=self.states.BIGVIRMENROAR
				self.statetimer=800
				--TODO: knock back player, spawn virmen
			elseif(self.state==self.states.BIGVIRMENROAR)then
				-- local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"- Windwalker Monk Basic Techniques -",3000)
				-- tm.dontlock=true

				self.bigvirmen:SetAnimationByIndex(55,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,1200)
				
				--print("!!!", currenttime)
				--self.bigvirmen.modelframe:SetAnimation(self.bigvirmen.attackanimation)
				self.statetimer=1200
				self.nextstate=self.states.SPAWNMINIONS

			elseif(self.state==self.states.SPAWNMINIONS)then
				-- The game doesn't like to spawn more than ~7 enemies at once
				-- so we have to bring them in one frame at a time in a later part of the function
				-- for now, just reserve their places  (this isn't strictly necessary)
				for i=1,8,1 do										
					self.virmen[i]=nil		
					self.virmenrespawntime[i]=0
					--print("!!!",i)
				end
			
				self.statetimer=3800				
				self.nextstate=self.states.TIGERPALM
			elseif(self.state==self.states.TIGERPALM)then
				self.bigvirmen:SetDefaultHP()
				self.bigvirmen.combat.hp.regenrate=250*2
				self.environment.camera:ChangeFocus(self.player)
				if(self.remembertargetzoom~=nil)then
					self.environment.camera.targetzoom=self.remembertargetzoom
				end
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"- Windwalker Monk Basic Techniques -",3000)
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF001: Tiger Palm |cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Chi generator|cFFFFFFFF ability. ")								
				self.statetimer=nil
				self.environment.player.combat:CreateTutorialSpellButtons(5) -- Tiger Palm
				self.player.combat.energy:setValue(130)		
				self.statetimer=3000
				self.nextstate=self.states.WAITFORTIGERPALM
			elseif(self.state==self.states.WAITFORTIGERPALM)then
				self.statetimer=nil
				self.nextstate=self.states.STRIKEOFTHEWINDLORD
			elseif(self.state==self.states.STRIKEOFTHEWINDLORD)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Shift+1: Strike of the Windlord |cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Very strong|cFFFFFFFF attack.  Costs 2 Chi.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")			
				self.statetimer=nil
				self.environment.player.combat:CreateTutorialSpellButtons(6) -- SotW
				self.statetimer=3000
				self.nextstate=self.states.WAITFORSTRIKEOFTHEWINDLORD
			elseif(self.state==self.states.WAITFORSTRIKEOFTHEWINDLORD)then
				self.statetimer=nil
				self.nextstate=self.states.FISTSOFFURY				
			elseif(self.state==self.states.FISTSOFFURY)then				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF002: Fists of Fury |cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Very strong|cFFFFFFFF attack.  Costs 3 Chi.")	
				self.statetimer=nil
				self.environment.player.combat:CreateTutorialSpellButtons(7) -- FoF
				self.statetimer=3000
				self.nextstate=self.states.WAITFORFISTSOFFURY
			elseif(self.state==self.states.WAITFORFISTSOFFURY)then
				self.statetimer=nil
				self.nextstate=self.states.HIGHPRIORITY	
			elseif(self.state==self.states.HIGHPRIORITY)then
				--skip
				self.statetimer=1
				self.nextstate=self.states.RISINGSUNKICK
			elseif(self.state==self.states.RISINGSUNKICK)then
				self.environment.player.combat:CreateTutorialSpellButtons(8) -- RSK
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF003: Rising Sun Kick|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Moderate|cFFFFFFFF attack.  Costs 2 Chi. ")
				self.statetimer=3000
				self.nextstate=self.states.WAITFORRISINGSUNKICK
			elseif(self.state==self.states.WAITFORRISINGSUNKICK)then
				self.statetimer=nil
				self.nextstate=self.states.MEDIUMPRIORITY
			elseif(self.state==self.states.MEDIUMPRIORITY)then
				--skip
				self.statetimer=1
				self.nextstate=self.states.COREROTATION
			elseif(self.state==self.states.COREROTATION)then				
				--skip
				self.statetimer=1
				self.nextstate=self.states.ATTHISPOINT
			elseif(self.state==self.states.ATTHISPOINT)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"By the way,")				
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1				
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"this demo assumes you're already familiar with the basic Windwalker rotation.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"The finished game will do a better job of |cFFFFFF00teaching you how to play|cFFFFFFFF.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				self.statetimer=7000
				self.nextstate=self.states.ADVANCEDTECHNIQUES
			elseif(self.state==self.states.ADVANCEDTECHNIQUES)then
				--skip
				self.statetimer=1
				self.nextstate=self.states.BLACKOUTKICK
			elseif(self.state==self.states.BLACKOUTKICK)then				
				self.environment.player.combat:CreateTutorialSpellButtons(9) -- BoK
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF004: Blackout Kick|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Weak |cFFFFFF00singletarget|cFFFFFFFF attack.  Costs 1 Chi. ")
				self.statetimer=3000
				self.nextstate=self.states.WAITFORBLACKOUTKICK
			elseif(self.state==self.states.WAITFORBLACKOUTKICK)then	
				self.statetimer=nil
				self.nextstate=self.states.SPINNINGCRANEKICK
			elseif(self.state==self.states.SPINNINGCRANEKICK)then				
				self.environment.player.combat:CreateTutorialSpellButtons(10) -- SCK
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Shift+4: Spinning Crane Kick|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Situational|cFFFFFFFF attack.  Costs 3 Chi. ")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"We're not even going to try to explain this one.")
				self.statetimer=3000
				self.nextstate=self.states.WAITFORSPINNINGCRANEKICK
			elseif(self.state==self.states.WAITFORSPINNINGCRANEKICK)then		
				self.statetimer=nil
				self.nextstate=self.states.LOWPRIORITY
			elseif(self.state==self.states.LOWPRIORITY)then				
				--skip
				self.statetimer=1
				self.nextstate=self.states.TIGEREYEBREW
			elseif(self.state==self.states.TIGEREYEBREW)then					
				self.environment.player.combat:CreateTutorialSpellButtons(11) -- TEB
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF006: Storm, Earth, and Fire|cFFFFFFFF ")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Cooldown.  2 charges.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Press the key again to |cFFFFFF00focus|cFFFFFFFF on your current target.")
				self.statetimer=5000
				self.nextstate=self.states.WAITFORTIGEREYEBREW
			elseif(self.state==self.states.WAITFORTIGEREYEBREW)then
				self.statetimer=nil
				-- skip roll and FSK!
				--self.nextstate=self.states.ROLL
				self.nextstate=self.states.SUMMARIZE
			elseif(self.state==self.states.ROLL)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF008: Roll|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(Remember, you can also use |cFFFFFF00MIDDLE MOUSE BUTTON|cFFFFFFFF to roll.)");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=3				
				self.statetimer=3000
				self.nextstate=self.states.FLYINGSERPENTKICK
			elseif(self.state==self.states.FLYINGSERPENTKICK)then	
				self.environment.player.combat:CreateTutorialSpellButtons(12) -- FSK
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF009: Flying Serpent Kick|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Sends you flying forward |cFFFFFF00very quickly|cFFFFFFFF.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Press the key again to |cFFFFFF00stop|cFFFFFFFF and |cFFFFFF00slam into the ground|cFFFFFFFF.")
				self.statetimer=3000
				self.nextstate=self.states.WAITFORFLYINGSERPENTKICK								
			elseif(self.state==self.states.WAITFORFLYINGSERPENTKICK)then					
				self.statetimer=nil	
				self.nextstate=self.states.SUMMARIZE				
			elseif(self.state==self.states.SUMMARIZE)then				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," To summarize: ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")				
				--TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"The bottom row of your actionbar uses |cFFFFFF001-9|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"The bottom row of your actionbar uses |cFFFFFF001-8|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"and the top row uses |cFFFFFF00Shift + 1-7|cFFFFFFFF.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(Use |cFFFFFF00R|cFFFFFFFF, not Shift+8, to use your speed boost.)")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")								
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"There are some abilities you haven't seen yet")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," that will be unlocked when you |cFFFFFF00choose your talents|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"in the upcoming stages.")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"These abilities use the same control scheme.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")												
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"We eventually hope to allow you to")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"customize your actionbar properly.")
				self.statetimer=3000
				self.nextstate=self.states.RUNAWAY				
			elseif(self.state==self.states.RUNAWAY)then				
				--print("state: \"RUNAWAY\"")			
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				self.statetimer=4000	--!!!
				self.nextstate=self.states.TOUCHOFDEATH				
			elseif(self.state==self.states.TOUCHOFDEATH)then						
				self.environment.player.combat:CreateTutorialSpellButtons(13) -- ToD
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF007: Touch of Death|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Deals |cFFFFFF00overwhelming|cFFFFFFFF damage after 8 seconds. Cooldown.")
				self.statetimer=3000
				self.nextstate=self.states.WAITFORTOUCHOFDEATH
			elseif(self.state==self.states.WAITFORTOUCHOFDEATH)then	
				self.statetimer=nil
				self.nextstate=self.states.WAITFORVIRMENCLEAR--!!!
			elseif(self.state==self.states.WAITFORVIRMENCLEAR)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				self.statetimer=nil
				self.nextstate=self.states.CONCLUSION--!!!
			elseif(self.state==self.states.CONCLUSION)then	
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"We made it through the tutorial without crashing!")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Rest assured though,")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"there's plenty of things left to break.")
				self.statetimer=5000
				self.nextstate=self.states.UNLOCK
			elseif(self.state==self.states.UNLOCK)then		
				TRAININGGROUNDS_VARS.progress=2
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"The next two stages have been unlocked.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"You'll be able to customize your |cFFFFFF00talents|cFFFFFFFF and |cFFFFFF00haste rating|cFFFFFFFF.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Now returning to the title screen...")
				self.statetimer=3000
				self.nextstate=self.states.END
				--!!!
			elseif(self.nextstate==self.states.END)then
				self.statetimer=nil
				self.nextstate=self.states.END
				self.environment.game:QuitLevelAndReturnToMenu()

				--TODO: transition back to titlescreen
			end
			--self.environment.player.combat:CreateTutorialSpellButtons(3)
			--
		end
	end
	
	--TODO: if player is targeting the rabbit and hasn't cleared the "attack something" phase,
	--	give them a hint to attack something else
	--		(or tell them to press TAB to change targets?)
	
	-- --!!!
	-- if(self.virmen[1]~=nil)then
		-- self.virmen[1].frame:Show()
		-- self.virmen[1].modelframe:Show()	
		-- print(self.virmen[1].frame:GetAlpha(),self.virmen[1].modelframe:GetAlpha())
		-- print(self.virmen[1].frame:GetPoint(1),self.virmen[1].modelframe:GetPoint(1))

	-- end
	
	--TODO: debug skip
	if(_TRAININGGROUNDS.debug_autoscenario==true)then
		if(self.nextstate==nil or self.nextstate<self.states.SPAWNPLAYER)then			
			self.nextstate=self.states.SPAWNPLAYER
			self.state=self.nextstate-1
		end
	
		-- if(self.state<self.states.WASD)then
		-- --if(self.state<self.states.PRESS1ATTACK)then
		-- --if(self.state<self.states.WAITFORZOOM)then
		-- --if(self.state<self.states.PRESS8ROLL)then
		-- -- if(self.state<self.states.SETUPPHASE2)then
			-- -- if(self.player~=nil)then
				-- -- self.player.x=0;self.player.y=0
			-- -- end
			-- self.statetimer=0
		-- end
		
		if(self.player~=nil and self.nextstate<self.states.SETUPPHASE2)then
			self.nextstate=self.states.SETUPPHASE2
		end
		-- if(self.player~=nil and self.state>self.states.TIGERPALM and self.nextstate<self.states.FLYINGSERPENTKICK)then
			-- self.nextstate=self.states.FLYINGSERPENTKICK
		-- end
		if(self.player~=nil and self.state>self.states.SPAWNMINIONS and self.nextstate<self.states.UNLOCK)then
			self.nextstate=self.states.UNLOCK
		end
		
		-- if(self.player~=nil and self.nextstate<self.states.WAITFORFLYINGSERPENTKICK)then
			-- self.statetimer=0
		-- end		
	end
	
	--print(self.state,self.states.UNLOCKCAMERA)
	if(self.state<self.states.UNLOCKCAMERA)then
		self.environment.camera.targetzoom=1
		self.environment.camera.zoom=self.environment.camera.targetzoom
		if(self.player~=nil)then
			--TODO: keep player in bounds
			local bounds=275
			if(self.player.x<-bounds)then self.player.x=-bounds end
			if(self.player.y<-bounds)then self.player.y=-bounds end
			if(self.player.x>bounds)then self.player.x=bounds end
			if(self.player.y>bounds)then self.player.y=bounds end
		
		end
	end
	
	if(self.state>=self.states.SETUPPHASE2 and self.state<=self.states.SPAWNMINIONS)then
		self.environment.camera.targetzoom=1
		-- we don't yet have a way to make the player jump back then stop,
		-- so stop them manually
		if(self.player.z<=0 and self.player.zspeed<=0)then
			self.player.xspeed=0
			self.player.yspeed=0
		end
	end
	
	if(self.state==self.states.WASD)then
		if(self.player~=nil)then
			if(self.player.x~=0 or self.player.y~=0)then
				self.statetimer=0
			end
		end
	elseif(self.state==self.states.LMBTARGET)then
		if(self.player~=nil and self.player.combat~=nil)then
			if(self.player.combat.targetchangecount>0)then
				self.statetimer=0
			end
		end
	elseif(self.state==self.states.PRESS1ATTACK)then
		if(self.player~=nil and self.player.combat~=nil)then
			if(self.player.combat.totalspellusecount>0)then
				self.statetimer=0
			end
		end
	elseif(self.state==self.states.WAITFORZOOM)then
		if(self.environment.camera~=nil and self.environment.camera.targetzoom~=1)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORRABBIT)then
		if(self.rabbitwaitstarttime==nil)then
			self.rabbitwaitstarttime=self.environment.currenttime
		else
			if(self.environment.currenttime>self.rabbitwaitstarttime+10000)then
				if(self.rabbitreminder~=true)then
					local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Find the rabbit and target it.")
					self.rabbitreminder=true
				end
			end
		end
		if(self.rabbit.deadingame==true
		or (self.player~=nil and self.player.combat.target==self.rabbit)
		)then
			self.statetimer=0			
		end
	elseif(self.state==self.states.WAITFORRABBITCLEAR)then
		if(self.rabbit2waitstarttime==nil)then
			self.rabbit2waitstarttime=self.environment.currenttime
		else
			if(self.environment.currenttime>self.rabbit2waitstarttime+10000)then
				if(self.rabbit2reminder~=true)then
					TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
					local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"If you're having trouble catching the rabbit,")
					local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"use your \"|cFFFFFF00R|cFFFFFFFF\" speed boost,")
					local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"then press |cFFFFFF001|cFFFFFFFF without touching any other controls.")
					self.rabbit2reminder=true
				end
			end
		end	
	
		if(self.rabbit~=nil and self.rabbit.deadingame==true)then		
			self.statetimer=0
			self.rabbit=nil
		end	
	elseif(self.state==self.states.WAITFORALLCLEAR)then
		--if(self.player~=nil and self.player.crittercount<=0)then		
		if(true)then	-- no longer 6 critters to get rid of
			--print("Self.player.crittercount is ",self.player.crittercount)
			self.statetimer=0
		end
	elseif(self.state==self.states.SETUPPHASE2)then
		if(self.bigvirmen~=nil and self.bigvirmen.z<=0)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORTIGERPALM)then
		if(self.player.combat.tigerpalm.usecount>0)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORFISTSOFFURY)then
		if(self.player.combat.fistsoffury.usecount>0)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORSTRIKEOFTHEWINDLORD)then
		if(self.player.combat.strikeofthewindlord.usecount>0)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORRISINGSUNKICK)then
		if(self.player.combat.risingsunkick.usecount>0)then			
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORBLACKOUTKICK)then
		if(self.player.combat.blackoutkick.usecount>0 or self.player.combat.fakecombobreakerblackoutkick.usecount>0)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORSPINNINGCRANEKICK)then
		if(self.player.combat.spinningcranekick.usecount>0)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORTIGEREYEBREW)then
		if(self.player.combat.tigereyebrew.usecount>0)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORFLYINGSERPENTKICK)then
		if(self.player.combat.flyingserpentkick.usecount>0)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORTOUCHOFDEATH)then
		if(self.player.combat.touchofdeath.usecount>0)then
			--print("Touch of Death usecount: ",self.player.combat.touchofdeath.usecount)
			self.statetimer=0
		end
	end
	
	if(self.state>=self.states.WAITFORTOUCHOFDEATH and self.state<=self.states.WAITFORVIRMENCLEAR)then
		if(self.bigvirmen.combat.hp.value<self.bigvirmen.combat.hp.max*0.1)then
			self.bigvirmen.combat.hp.regenrate=0
			self.bigvirmen.combat.hp.value=0			
		end
	end
	
	if(self.state==self.states.WAITFORVIRMENCLEAR)then
		if(self.bigvirmen.deadingame==true or self.bigvirmen.dead==true)then
			self.statetimer=0
		end
	end	
	
	if(self.state>=self.states.SPAWNMINIONS and self.state<self.states.RUNAWAY)then
		local i
		for i=1,8,1 do
			if(self.virmen[i]==nil or self.virmen[i].dead==true)then
				if(self.virmenrespawntime[i]~=nil)then
					self.virmenrespawntime[i]=self.virmenrespawntime[i]-elapsed*1000
					if(self.virmenrespawntime[i]<=0)then self.virmenrespawntime[i]=0 end				
				end
			end
		end
	
	
		self.nextminionspawnframecount=self.nextminionspawnframecount+1
		if(currenttime>=self.nextminionspawntime and self.nextminionspawnframecount>5)then			
			self.nextminionspawnframecount=0
			self.nextminionspawntime=currenttime+100
			local i
			local continue=true
			for i=1,8,1 do
				if(continue==true)then
					-- if(_TRAININGGROUNDS.game.keys.ctrl.current==true)then
						-- print(i, self.virmen[i])
						-- if(self.virmen[i]~=nil)then print(self.virmen[i].dead) end
					-- end
					if(self.virmen[i]==nil or self.virmen[i].dead==true)then
						if(self.virmenrespawntime[i]~=nil)then
							if(self.virmenrespawntime[i]<=0)then							
								self:NewVirmenAtIndex(i,currenttime)
								--self.virmenrespawntime[i]=5000
								self.virmenrespawntime[i]=10000
								continue=false
							end
						end
					end
				end
			end
		end
	end
	
	if(self.state==self.states.RUNAWAY)then
		for i=1,8,1 do
			if(self.virmen[i]~=nil and self.virmen[i].deadingame~=true)then
				self.virmen[i]:runawaystep(elapsed,i)
			end
		end
	end
	

	
end


function TRAININGGROUNDS_ScenarioController_Tutorial:NewVirmenAtIndex(i,currenttime)
	local angle=math.pi*2/8*(i-1)+math.pi
	--TODO: move to function; reuse function for replacements
	--TODO: change combat
	local virmen=TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen.new()
	--print("Calling setup on new virmen ",i)
	virmen:setup(self.environment);
	virmen.x=200*math.cos(angle)
	virmen.y=200*math.sin(angle)
	--print("NewVirmenAtIndex ",i,virmen.x,virmen.y)	
	virmen.combat=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.new();virmen.combat:setup(virmen)
	virmen:SetDefaultHP()
	local buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new()
	buff:setup(virmen.combat,currenttime);	virmen.modelframe:SetAlpha(0)
	virmen:SetAdjustedFacing(angle+math.pi/2)
	--virmen.modelframe:SetFacing(0)
	virmen.z=500--+(i*50)
	--virmen.zspeed=i*50
	self.virmen[i]=virmen
	
	-- if(i==1) then 
		-- print("NewVirmenAtIndex")
		-- TRAININGGROUNDS_FrameVisibilityCheck(virmen.frame)
		-- print("Tag: ",virmen.frame.tag)
	-- end
end