TRAININGGROUNDS_TemporaryTextField = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_TemporaryParticleFrame)

-- When creating a textbox, you'll need to call setup() to create the text frame,
-- then call SetText on the created frame,
-- then call draw() again to refresh the frame before the screen is drawn.


function TRAININGGROUNDS_TemporaryTextField:step(elapsed)
	TRAININGGROUNDS_TemporaryParticleFrame.step(self,elapsed)
	
	-- SetJustifyH occasionally fails on creation, so set it every frame
		-- -- it turns out setting it every frame doesn't work either
	--self.frame.fontstring:SetJustifyH("LEFT")
	
	
	-- if(self.x~=25 and self.x~=nil)then
		-- print("!!! ",self.x)
		-- error(0)
	-- end
	--print("Textfield currenttime: ",self.environment.currenttime,"expiry:",self.expirytime)
	
end

function TRAININGGROUNDS_TemporaryTextField:SetAppearance()
	
	--self.frame:Show()	
	self.frame.tag="TemporaryTextField"
	self.frame.fontstring:Show()	
	--print("TemporaryTextField:SetAppearance "..self.text)	
	self.alignment="TOPLEFT"
	
	if(_TRAININGGROUNDS.debug_showtextframes==true)then
		self.frame.texture:Show()
	end
end

function TRAININGGROUNDS_TemporaryTextField:SetFrameSize()
	-- don't call super; text doesn't depend on camera zoom
	-- TODO: resize text based on camera zoom, maybe
end