TRAININGGROUNDS_Enemy = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_WoWCharacter)

--TODO: move to enemy.combat?
function TRAININGGROUNDS_Enemy:SetDefaultHP()
	if(self.defaulthp~=nil)then
		--TODO: game.environment.enemyhpmultiplier
		local multiplier=1*self:GetHPMultiplier()
		self.combat:SetMaximumAndCurrentHP(math.floor(self.defaulthp*multiplier))
		--print("SetDefaultHP ",defaulthp*multiplier)
	end
end

function TRAININGGROUNDS_Enemy:GetHPMultiplier()
	local hastemultiplier=(_TRAININGGROUNDS.game.targethaste-1)*0.1
	hastemultiplier=hastemultiplier*0.5		-- this is considered to be our current compensation for not scaling player HP up for touch of death
														-- (TODO:) 
	hastemultiplier=1+hastemultiplier
	local masterymultiplier=1.2
	
	local extramultiplier=0.75
	
	return 1*masterymultiplier*hastemultiplier*extramultiplier
end

--TODO: different way of handling HP<=1
function TRAININGGROUNDS_Enemy:step(elapsed)
	TRAININGGROUNDS_WoWCharacter.step(self,elapsed)
	
	if(self.combat~=nil)then
		if(self.combat.hp.value<=1)then
			if(self.combat.hp.regenrate==0)then
				if(self.deadingame~=true)then
					self:DieInGame(self.environment.currenttime)
				end
			end
		end
	end
end

--!!!
function TRAININGGROUNDS_Enemy:StrikeOfTheWindlordStagger()
	--self:SetAnimationByIndex(8,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,500)
	self:SetAnimationByIndex(8,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.DAMAGE,500)
end