TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Enemy)

function TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen:SetCustomInfo()
	TRAININGGROUNDS_Enemy.SetCustomInfo(self)
	
	self.defaulthp=TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP/4
end

function TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen:SetModelSpecificInfo()
	-- override
	-- do not call super when overriding

	-- Large Illusionary Varmint
	self.modelframe:SetDisplayInfo(48909)
	self.modelinfo.sideviewoffsetY=174
	self.modelinfo.sideviewclickheight=170
	self.modelinfo.topviewoffsetY=-70
	self.modelinfo.clickwidth=190
	self.modelinfo.offsetX=0
	self.modelinfo.gameplayscaleratio=.5

	self.npcanimations={}
	self.npcanimations["LandOnGround"]={};self.npcanimations["LandOnGround"].duration=500
end

function TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen:StrikeOfTheWindlordStagger()
	--self:SetAnimationByIndex(8,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,500)
	self:SetAnimationByIndex(8,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.DAMAGE,500)
end

--TODO:
function TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen:step(elapsed)
	TRAININGGROUNDS_Enemy.step(self,elapsed)

	if(self.deadingame~=true)then
		if(self.combat~=nil and self.combat.hp.value~=nil)then
			
			if(self.combat.hp.value<=1)then	
				--TODO: maybe die on the tick we reach <= 1 HP (not necessarily consistent with WoW, though)
				self:DieInGame(self.environment.currenttime)
			end
		end
	end
end

--this is called by scenariocontroller_tutorial
function TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen:runawaystep(elapsed,index)
	self.cangooob=true
	if(self.deadingame==false)then
		local angle=math.pi*2/8*(index-1)+math.pi
		local moveangle=angle
		local MOVESPEED=325
		self.xspeed=math.cos(moveangle)*MOVESPEED
		self.yspeed=math.sin(moveangle)*MOVESPEED
		--print(self.xspeed,self.yspeed)
		
		
		self.movevectorxx=self.xspeed
		self.movevectoryy=self.yspeed
		self.movespeed=1.8	--TODO:  (this only affects the displayed animation)
		--self.movespeed=math.sqrt((self.xspeed*self.xspeed)+(self.yspeed*self.yspeed))
		
		local turnspeed=1
		local movevectorfacing=math.atan2(self.movevectorxx,-self.movevectoryy)
		self:changeFacing(movevectorfacing,elapsed,turnspeed)
	else
		self.xspeed=0
		self.yspeed=0
	end
	
	if(self.expirytime==nil)then
		self.expirytime=self.environment.currenttime+3000
	else
		local a=(self.expirytime-self.environment.currenttime)/1000.0
		if(a>1)then 
			a=1 
		else
			self.modelframe:SetAlpha(a)
		end
	end
end