TRAININGGROUNDS_FakePlayerCharacter_Priest = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_Priest:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)
	self:ApplyDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_Priest:SetEquipmentInfo()
	self.equipment=TRAININGGROUNDS_Equipment.new()

	self.equipment:EquipItemToKnownSlot(119686,"ChestSlot")
	self.equipment:EquipItemToKnownSlot(119682,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(119683,"HandsSlot")
	self.equipment:EquipItemToKnownSlot(119684,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(119685,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(119687,"ShoulderSlot")
	self.equipment:EquipItemToKnownSlot(119688,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(119689,"WristSlot")	
	self.equipment:EquipItemToKnownSlot(119680,"MainHandSlot")	
	self.equipment:EquipItemToKnownSlot(119681,"BackSlot")		
	
	-- for i=119682,119689,1 do
		-- self.equipment:TryItem(i)	
	-- end	
end

function TRAININGGROUNDS_FakePlayerCharacter_Priest:Is2HOnTitleScreen()
	return true
end

function TRAININGGROUNDS_FakePlayerCharacter_Priest:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		FakePlayerCharacterTitleAnimations.UndirectedSpellcast,
		FakePlayerCharacterTitleAnimations.UndirectedSpellcast,
		FakePlayerCharacterTitleAnimations.TwoHandBasicAttack1
	}
	return sequences
end