TRAININGGROUNDS_FakePlayerCharacter_Rogue = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_Rogue:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)
	self:ApplyDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_Rogue:SetEquipmentInfo()
	self.equipment=TRAININGGROUNDS_Equipment.new()

	self.equipment:EquipItemToKnownSlot(119697,"ChestSlot")
	self.equipment:EquipItemToKnownSlot(119698,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(119699,"HandsSlot")
	self.equipment:EquipItemToKnownSlot(119700,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(119701,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(119702,"ShoulderSlot")
	self.equipment:EquipItemToKnownSlot(119703,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(119704,"WristSlot")	
	self.equipment:EquipItemToKnownSlot(119705,"MainHandSlot")	
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		self.equipment:EquipItemToKnownSlot(119705,"SecondaryHandSlot")	
	else
		--self.equipment:EquipItemToKnownSlot(9769,"SecondaryHandSlot")
		self.equipment:EquipItemToKnownSlot(9914,"SecondaryHandSlot")
	end	
	
	
	self.equipment:EquipItemToKnownSlot(119691,"BackSlot")		
	
	-- for i=119697,119704,1 do
		-- self.equipment:TryItem(i)	
	-- end	
end


function TRAININGGROUNDS_FakePlayerCharacter_Rogue:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.OneHandBasicAttack,
		FakePlayerCharacterTitleAnimations.OneHandFancyAttack,
		FakePlayerCharacterTitleAnimations.StealthWalk
	}
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldFancyAttack)
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldSlashCombo)
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldStabCombo)
		
	end
	return sequences
end