--TODO: in addition to all the information we're already collecting,
-- there oughta be a way to keep track of the position of the vertical axis each model revolves around

TRAININGGROUNDS_PlayerCharacterModelInfo={}

TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable={} 	-- "Race-to-ID Table"
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Human"]=1
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Orc"]=2
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Dwarf"]=3
--TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Night Elf"]=4
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["NightElf"]=4
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Undead"]=5
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Scourge"]=5
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Tauren"]=6
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Gnome"]=7
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Troll"]=8
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Goblin"]=9
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["BloodElf"]=10
--TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Blood Elf"]=10
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Draenei"]=11
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Worgen"]=22
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Pandaren"]=24	--TODO: ...this just sets the same value 3 times...
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Pandaren"]=25	--TODO: ...this just sets the same value 3 times...
TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Pandaren"]=26	--TODO: ...this just sets the same value 3 times...

TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable={} 	-- "Race-to-ID Table"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[1]="Human"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[2]="Orc"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[3]="Dwarf"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[4]="Night Elf"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[5]="Undead"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[6]="Tauren"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[7]="Gnome"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[8]="Troll"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[9]="Goblin"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[10]="Blood Elf"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[11]="Draenei"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[22]="Worgen"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[24]="Pandaren"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[25]="Pandaren"
TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable[26]="Pandaren"	


-- we're not sure this needs to be stored locally, but we might decide to convert to non-array ids later
-- TODO: decide if we're better off just using GetInventorySlotInfo everywhere
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID={}
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["BackSlot"]=GetInventorySlotInfo("BackSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["ChestSlot"]=GetInventorySlotInfo("ChestSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["FeetSlot"]=GetInventorySlotInfo("FeetSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["HandsSlot"]=GetInventorySlotInfo("HandsSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["HeadSlot"]=GetInventorySlotInfo("HeadSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["LegsSlot"]=GetInventorySlotInfo("LegsSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["MainHandSlot"]=GetInventorySlotInfo("MainHandSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["SecondaryHandSlot"]=GetInventorySlotInfo("SecondaryHandSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["ShirtSlot"]=GetInventorySlotInfo("ShirtSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["ShoulderSlot"]=GetInventorySlotInfo("ShoulderSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["TabardSlot"]=GetInventorySlotInfo("TabardSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["WaistSlot"]=GetInventorySlotInfo("WaistSlot")
TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["WristSlot"]=GetInventorySlotInfo("WristSlot")


-- Prohibited items count as nothing equipped during iscustomraceallowed check
TRAININGGROUNDS_PlayerCharacterModelInfo.prohibitedequipment={}
TRAININGGROUNDS_PlayerCharacterModelInfo.prohibitedequipment[59253]=true

TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable={}
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[1]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[3]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[5]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[6]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[7]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[8]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[9]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[10]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[15]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[16]=true
TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[17]=true


function TRAININGGROUNDS_PlayerCharacterModelInfo.SetModelframeToPlayerAndReturnModelInfo(modelframe)
	modelframe:SetUnit("player")	
	
	local raceid,sex=TRAININGGROUNDS_PlayerCharacterModelInfo.GetModelframeRace(modelframe)
	local modelinfo=TRAININGGROUNDS_PlayerCharacterModelInfo.GetModelInfoByRace(raceid,sex)
	
	return modelinfo,raceid,sex	
end

function TRAININGGROUNDS_PlayerCharacterModelInfo.GetModelframeRace(modelframe)
	local modelfilename=modelframe:GetModel()	
	if(modelfilename==nil)then return nil, nil end
	
	local raceid,sex
	for i,v in pairs(TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable) do
		if(modelfilename:lower():find(i:lower())~=nil)then
			raceid=v
		end
	end
	if(modelfilename:lower():find("female")~=nil)then
		sex=1
	elseif(modelfilename:lower():find("male")~=nil)then
		sex=0
	end
	return raceid,sex
end

function TRAININGGROUNDS_PlayerCharacterModelInfo.GetPlayerDefaultEquipment()
	local equipment=TRAININGGROUNDS_Equipment.new()
	for i=0,19,1 do
		equipment.items[i]=GetInventoryItemID("player",i)
		if(TRAININGGROUNDS_PlayerCharacterModelInfo.slotistrangmogrifiable[i]~=nil)then
			local isTransmogrified, canTransmogrify, cannotTransmogrifyReason, hasPending, hasUndo, visibleItemID, textureName = GetTransmogrifySlotInfo(i)
			if(isTransmogrified==true)then
				equipment.items[i]=visibleItemID
			end
		end
	end
	return equipment
end


-- attempt to set player model's equipment, race, or sex.
-- under certain conditions, race and sex cannot be changed.
-- leaving any of these nil will default to the WoW player's equipment, race, or sex.
function TRAININGGROUNDS_PlayerCharacterModelInfo.AttemptSetCustomAppearanceAndReturnModelInfo(modelframe,equipment,raceid,sex)
	--print("TRAININGGROUNDS_PlayerCharacterModelInfo.AttemptSetCustomAppearanceAndReturnModelInfo(modelframe,equipment,raceid,sex)")
	local newequipment=true
	if(equipment==nil)then
		newequipment=false
		equipment=TRAININGGROUNDS_PlayerCharacterModelInfo.GetPlayerDefaultEquipment()
	end
	if(raceid~=nil or sex~=nil)then
		if(raceid==nil or sex==nil)then
			local oldraceid,oldsex=TRAININGGROUNDS_PlayerCharacterModelInfo.GetModelframeRace(modelframe)
			if(raceid==nil)then raceid=oldraceid end
			if(sex==nil)then sex=oldsex end
		end
		if(TRAININGGROUNDS_PlayerCharacterModelInfo.IsCustomRaceAllowed(equipment,raceid,sex)==true)then
			modelframe:SetCustomRace(raceid,sex)
		end
	end
	-- update raceid and sex with current model info, whether we changed it or not...
	local raceid,sex=TRAININGGROUNDS_PlayerCharacterModelInfo.GetModelframeRace(modelframe)
	local modelinfo=TRAININGGROUNDS_PlayerCharacterModelInfo.GetModelInfoByRace(raceid,sex)	
	
	if(newequipment==true)then
		--if raceid is nil, then the model didn't load correctly and there's no point in changing equipment at the moment
		if(raceid~=nil)then	
			for i=1,19,1 do
				if(equipment.items[i]==nil)then
					modelframe:UndressSlot(i)
				else
					-- This undocumented feature of TryOn is the only way to persuade Hunters to equip weapons to offhand.
					-- It can be used to equip weapons to offhand for non-DW classes, but it removes their mainhand item.
					if(i==TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["SecondaryHandSlot"])then						
						modelframe:TryOn(equipment.items[i],"offhand")		
					else
						modelframe:TryOn(equipment.items[i])
					end
					
				end
			end
		end
	end

	return modelinfo,raceid,sex
end

function TRAININGGROUNDS_PlayerCharacterModelInfo.IsCustomRaceAllowed(equipment,raceid,sex)
	-- This check is mandatory for all characters with variable equipment.
	-- Bypassing this check is potentially a violation of the World of Warcraft User Interface Add-On Development Policy.
	if(equipment==nil)then return false end
	
	if((sex==0 or
		(TRAININGGROUNDS_PlayerCharacterModelInfo.IsEquipmentSlotOKForRaceChange(equipment,"ChestSlot")==true
			or TRAININGGROUNDS_PlayerCharacterModelInfo.IsEquipmentSlotOKForRaceChange(equipment,"ShirtSlot")==true
			or TRAININGGROUNDS_PlayerCharacterModelInfo.IsEquipmentSlotOKForRaceChange(equipment,"TabardSlot")==true
			)) 
		and TRAININGGROUNDS_PlayerCharacterModelInfo.IsEquipmentSlotOKForRaceChange(equipment,"LegsSlot")==true)then return true end
	
	return false
end

function TRAININGGROUNDS_PlayerCharacterModelInfo.IsEquipmentSlotOKForRaceChange(equipment,slotstring)
	
	local itemid=equipment.items[TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID[slotstring]]
	--print("Checking slot "..TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID[slotstring].." (contains "..tostring(itemid)..")")
	if(itemid==nil)then return false end
	if(TRAININGGROUNDS_PlayerCharacterModelInfo.prohibitedequipment[itemid]~=nil)then return false end
	--print("OK")
	return true	
end

function TRAININGGROUNDS_PlayerCharacterModelInfo.GetModelInfoByRace(raceid,sex)
	-- Steps for editing modelinfo data:	
		-- Turn on visible clickareas and targetable player (so target circle is visible)
		-- Position camera directly to the side and adjust sideviewoffsetY.
			-- Feet should be lined up with the bottom of clickarea.
			-- Zoom in camera to be sure feet are lined up.
		-- Adjust sideviewclickheight.  Leave room for nameplate.
		-- Change camera to top view and adjust topviewoffsetY.
		-- Adjust clickwidth.  (Clickarea height in overhead view varies with clickwidth.  Final clickheight in overhead view will still be taller than it should be.)
		-- Adjust offsetX.  (Rotate model; some of them are unavoidably off center at different angles)
		-- Change camera to 3/4 view and check if everything looks reasonable.
			-- If Y offset looks bad in 3/4 view, adjust topviewoffsetY.
			-- Rotate model; some models aren't centered on target circle.  Find a compromise where model looks half reasonable no matter where they're facing.
			-- If Y offset still doesn't look ok in both 3/4 view and top view, increase clickwidth to increase shadow side.
			-- priority is 3/4 view over top view, since we'll be spending most of our time in 3/4
				-- and remember that overhead view isn't completely 100% overhead.
		-- Set FakePlayerCharacter race/sex.
		-- Open the "class model alignment" menu and adjust gameplay and portrait scale ratios.
			-- double check running animation in gameplay environment
		
	-- TODO: haven't actually double checked running animation in gameplay environment

	local modelinfo={}

	if(raceid==1 and sex==0) then
		-- Human M		
		modelinfo.sideviewoffsetY=115		
		modelinfo.sideviewclickheight=117
		modelinfo.topviewoffsetY=60				
		modelinfo.clickwidth=80
		modelinfo.offsetX=3
		modelinfo.gameplayscaleratio=1.15
	elseif(raceid==1 and sex==1) then
		-- Human F		
		modelinfo.sideviewoffsetY=265
		modelinfo.sideviewclickheight=139
		modelinfo.topviewoffsetY=27
		modelinfo.clickwidth=80		
		modelinfo.offsetX=9
		modelinfo.gameplayscaleratio=1
	elseif(raceid==2 and sex==0) then
		-- Orc M		
		modelinfo.sideviewoffsetY=137		
		modelinfo.sideviewclickheight=132
		modelinfo.topviewoffsetY=20	
		modelinfo.clickwidth=110
		modelinfo.offsetX=0
		modelinfo.gameplayscaleratio=1
	elseif(raceid==2 and sex==1) then
		-- Orc F		
		modelinfo.sideviewoffsetY=118
		modelinfo.sideviewclickheight=117
		modelinfo.topviewoffsetY=50
		modelinfo.clickwidth=80
		modelinfo.offsetX=0
		modelinfo.gameplayscaleratio=1.2
	elseif(raceid==3 and sex==0) then
		-- Dwarf M		
		modelinfo.sideviewoffsetY=197	
		modelinfo.sideviewclickheight=115
		modelinfo.topviewoffsetY=10
		modelinfo.clickwidth=100
		modelinfo.offsetX=6
		modelinfo.gameplayscaleratio=1
	elseif(raceid==3 and sex==1) then
		-- Dwarf F		
		modelinfo.sideviewoffsetY=86
		modelinfo.sideviewclickheight=78
		modelinfo.topviewoffsetY=17
		modelinfo.clickwidth=70
		modelinfo.offsetX=-4
		modelinfo.gameplayscaleratio=1.45
	elseif(raceid==4 and sex==0) then
		-- Night Elf M		
		modelinfo.sideviewoffsetY=160		
		modelinfo.sideviewclickheight=161
		modelinfo.topviewoffsetY=65
		modelinfo.clickwidth=80
		modelinfo.offsetX=0
		modelinfo.gameplayscaleratio=.9
	elseif(raceid==4 and sex==1) then
		-- Night Elf F		
		modelinfo.sideviewoffsetY=151
		modelinfo.sideviewclickheight=157
		modelinfo.topviewoffsetY=65
		modelinfo.clickwidth=70
		modelinfo.offsetX=0		
		modelinfo.gameplayscaleratio=.9
	elseif(raceid==5 and sex==0) then
		-- Undead M	
		modelinfo.sideviewoffsetY=108
		modelinfo.sideviewclickheight=105
		modelinfo.topviewoffsetY=55
		modelinfo.clickwidth=80
		modelinfo.offsetX=-9
		modelinfo.gameplayscaleratio=1.25
	elseif(raceid==5 and sex==1) then
		-- Undead F		
		modelinfo.sideviewoffsetY=261
		modelinfo.sideviewclickheight=132
		modelinfo.topviewoffsetY=8
		modelinfo.clickwidth=80
		modelinfo.offsetX=5		
		modelinfo.gameplayscaleratio=1
	elseif(raceid==6 and sex==0) then
		-- Tauren M		
		modelinfo.sideviewoffsetY=138		
		modelinfo.sideviewclickheight=143
		modelinfo.topviewoffsetY=-25
		modelinfo.clickwidth=112
		modelinfo.offsetX=-3
		modelinfo.gameplayscaleratio=1
	elseif(raceid==6 and sex==1) then
		-- Tauren F		
		modelinfo.sideviewoffsetY=128
		modelinfo.sideviewclickheight=125
		modelinfo.topviewoffsetY=6
		modelinfo.clickwidth=72
		modelinfo.offsetX=2
		modelinfo.gameplayscaleratio=1.1
	elseif(raceid==7 and sex==0) then
		-- Gnome M		
		modelinfo.sideviewoffsetY=77
		modelinfo.sideviewclickheight=70
		modelinfo.topviewoffsetY=10
		modelinfo.clickwidth=67
		modelinfo.offsetX=0
		modelinfo.gameplayscaleratio=1.4
	elseif(raceid==7 and sex==1) then
		-- Gnome F		
		modelinfo.sideviewoffsetY=70
		modelinfo.sideviewclickheight=62
		modelinfo.topviewoffsetY=16
		modelinfo.clickwidth=62
		modelinfo.offsetX=0	
		modelinfo.gameplayscaleratio=1.5
	elseif(raceid==8 and sex==0) then
		-- Troll M	
		modelinfo.sideviewoffsetY=173
		modelinfo.sideviewclickheight=167
		modelinfo.topviewoffsetY=25
		modelinfo.clickwidth=112
		modelinfo.offsetX=0
		modelinfo.gameplayscaleratio=.8
	elseif(raceid==8 and sex==1) then
		-- Troll F		
		modelinfo.sideviewoffsetY=146
		modelinfo.sideviewclickheight=139
		modelinfo.topviewoffsetY=9
		modelinfo.clickwidth=67
		modelinfo.offsetX=-6
		modelinfo.gameplayscaleratio=1
	elseif(raceid==9 and sex==0) then
		-- Goblin M	
		modelinfo.sideviewoffsetY=112
		modelinfo.sideviewclickheight=97
		modelinfo.topviewoffsetY=19
		modelinfo.clickwidth=92
		modelinfo.offsetX=-1
		modelinfo.gameplayscaleratio=1
	elseif(raceid==9 and sex==1) then
		-- Goblin F		
		modelinfo.sideviewoffsetY=111
		modelinfo.sideviewclickheight=99
		modelinfo.topviewoffsetY=15
		modelinfo.clickwidth=76
		modelinfo.offsetX=-1
		modelinfo.gameplayscaleratio=1
	elseif(raceid==10 and sex==0) then
		-- Blood Elf M	
		modelinfo.sideviewoffsetY=134
		modelinfo.sideviewclickheight=135
		modelinfo.topviewoffsetY=61
		modelinfo.clickwidth=75
		modelinfo.offsetX=-10
		modelinfo.gameplayscaleratio=1
	elseif(raceid==10 and sex==1) then
		-- Blood Elf F		
		modelinfo.sideviewoffsetY=113
		modelinfo.sideviewclickheight=112
		modelinfo.topviewoffsetY=51
		modelinfo.clickwidth=53
		modelinfo.offsetX=7
		modelinfo.gameplayscaleratio=1.15
	elseif(raceid==11 and sex==0) then
		-- Draenei M	
		modelinfo.sideviewoffsetY=193
		modelinfo.sideviewclickheight=182
		modelinfo.topviewoffsetY=14
		modelinfo.clickwidth=112
		modelinfo.offsetX=0
		modelinfo.gameplayscaleratio=.8
	elseif(raceid==11 and sex==1) then
		-- Draenei F		
		modelinfo.sideviewoffsetY=143
		modelinfo.sideviewclickheight=137
		modelinfo.topviewoffsetY=3
		modelinfo.clickwidth=63
		modelinfo.offsetX=-2
		modelinfo.gameplayscaleratio=1
	elseif(raceid==22 and sex==0) then
		-- Worgen M	
		modelinfo.sideviewoffsetY=370
		modelinfo.sideviewclickheight=210
		modelinfo.topviewoffsetY=-73
		modelinfo.clickwidth=140
		modelinfo.offsetX=5
		modelinfo.gameplayscaleratio=0.67
	elseif(raceid==22 and sex==1) then
		-- Worgen F		
		modelinfo.sideviewoffsetY=174
		modelinfo.sideviewclickheight=155
		modelinfo.topviewoffsetY=-50
		modelinfo.clickwidth=70
		modelinfo.offsetX=0	
		modelinfo.gameplayscaleratio=1
	elseif ((raceid==24 or raceid==25 or raceid==26) and sex==0) then
		--Pandaren M	
		modelinfo.sideviewoffsetY=156
		modelinfo.sideviewclickheight=135
		modelinfo.topviewoffsetY=-34
		modelinfo.clickwidth=112
		modelinfo.offsetX=3
		modelinfo.gameplayscaleratio=1
	elseif ((raceid==24 or raceid==25 or raceid==26) and sex==1) then
		--Pandaren F
		modelinfo.sideviewoffsetY=141
		modelinfo.sideviewclickheight=125
		modelinfo.topviewoffsetY=-33
		modelinfo.clickwidth=83
		modelinfo.offsetX=2
		modelinfo.gameplayscaleratio=1
	else
		-- we can expect to arrive here if the model failed to load,
		-- so we only need to print an error message if the current raceid/sex is something we're not familiar with
		if(raceid~=nil and sex~=nil)then
			print("TRAININGGROUNDS_PlayerCharacterModelInfo.GetModelInfoByRace(raceid,sex) Unknown raceid/sex: "..tostring(raceid).." / "..tostring(sex))
		end
		
		-- Human M		
		modelinfo.sideviewoffsetY=115		
		modelinfo.sideviewclickheight=117
		modelinfo.topviewoffsetY=60				
		modelinfo.clickwidth=80
		modelinfo.offsetX=3
		modelinfo.gameplayscaleratio=1
	end
	return modelinfo
end

