TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Buff)

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit_DebugPrintChiOrbitInfo()
	if(_TRAININGGROUNDS.game.environment_world.player~=nil)then
		local buff=_TRAININGGROUNDS.game.environment_world.player.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit)
		print("Orbs:")
		for i=1,4,1 do
			print("Slot ",i,":")
			if(buff.orbs[i]~=nil and buff.orbs[i].dead~=true)then
				print(buff.orbs[i])
				print("Deadingame: ",buff.orbs[i].deadingame)
				print("Slot: ",buff.orbs[i].slot)
			end
		end
	else
		print("Couldn't find player")
	end
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit:setCustomBuffInfo(combat,executiontime)
	TRAININGGROUNDS_Buff.setCustomBuffInfo(self,combat,executiontime)
	self.duration=nil	
	self.visibletoplayer=false

	self.tickfrequency=5000
	--self.tickfrequency=1000  --!!!
	self.tickonbuffstart=false
	
	self.orbdamage=500	
	self.orbs={}
	self.angle=0
end




function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit:step(elapsed,currenttime)
	TRAININGGROUNDS_Buff.step(self,elapsed,currenttime)
	
	self.angle=self.angle-0.3*elapsed
--print(self.nextticktime)
end


function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit:OnBuffTick(ticktime)
	TRAININGGROUNDS_Buff.OnBuffTick(self,ticktime)

	--look for a free orb slot
	local i
	local o=nil
	local emptycount=0	-- if all orb slots are empty, reset angle
	for i=1,4,1 do
		if(self.orbs[i]==nil or self.orbs[i].dead==true)then
			if(o==nil)then
				o=i
			end
			emptycount=emptycount+1
		end		
	end
	if(emptycount>=4)then
		self.angle=0
	end
	if(o~=nil)then
	--if(o~=nil and o==1)then
		local orb=TRAININGGROUNDS_Particle_ChiOrbit.new()
		orb:setup(self.combat.character.environment)
		orb.character=self.combat.character
		orb.x=self.combat.character.x
		orb.y=self.combat.character.y
		orb.z=50	--TODO: possibly change chiburst.z to 50 too
		orb.gravity=0
		local speed=875	
		orb.cangooob=true
		orb.buff=self
		orb.slot=o			
		self.orbs[o]=orb
	end
		
end


function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ChiOrbit:OnProjectileHit(ticktime,enemy)
	self.combat:ApplyDamageToEnemy(self.orbdamage,enemy)
end
