TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Buff)


-- FSK allegedly lasts for 2 seconds, but we hit the edge of the arena before then.
-- leaving it at 1200 for now -- might revisit it later
-- TODO: change icon when FSK is active (priest_icon_chakra_green)
TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick.FSKDURATION=1200

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick:setCustomBuffInfo(combat)
	TRAININGGROUNDS_Buff.setCustomBuffInfo(self,combat)
	self.duration=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick.FSKDURATION
	self.visibletoplayer=false
	

	self.requirestarget=false
	self.range=nil
	
	-- slam attack: duration 750, index 706 for monk stance, 712 for stance 0
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick:OnBuffStart()

	
	--TODO: if player is inputting any movement direction, roll in that direction instead
	--TODO: slight change to player's midair speed when roll starts

	self.combat.character.lockfacingendtick=self.starttime+self.duration
	self.combat.character.lockmovementendtick=self.starttime+self.duration
	--print(self.starttime+self.duration)
	
	
	-- if character is moving in a direction, we want to be sure we're facing in that direction (normally takes a second or two to turn around
		-- * however, at the moment, there's no control to jump forward and roll backward, and that messes up appearances
		-- until we have a way to start a roll in midair in a different direction from the way we're moving, just roll the way we're facing in midair and ignore movement
	if(self.combat.character.z<=0 and (self.combat.character.xspeed~=0 or self.combat.character.yspeed~=0))then
	--if((self.combat.character.xspeed~=0 or self.combat.character.yspeed~=0))then
		self.combat.character.currentfacing=math.atan2(self.combat.character.xspeed,-self.combat.character.yspeed)
		--print(self.combat.character.currentfacing)
		self.combat.character:SetAdjustedFacing(self.combat.character.currentfacing)
	end
	
	
	self.rollxx=math.sin(self.combat.character.currentfacing)
	self.rollyy=-math.cos(self.combat.character.currentfacing)	
	
	if(self.combat.character.z>0)then
		
	end
	
	--self.combat.character.attackanimation=664
	--self.combat.character.attackanimationendtick=self.starttime+500
	--self.combat.character:changeFrameAnimation(self.combat.character.attackanimation)
	self.combat.character:SetAnimationByIndex(704,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,500)

	--print(self.combat.character.attackanimationendtick)
	
	if(self.combat.flyingserpentkick.button~=nil)then
		self.combat.flyingserpentkick.button.frame.texture:SetTexture("Interface\\Icons\\priest_icon_chakra_green")
	end
	
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick:OnReapply(existingbuff, executiontime)
	TRAININGGROUNDS_Buff.OnReapply(self, existingbuff, executiontime)
	self.combat.character.lockfacingendtick=executiontime+self.duration
	self.combat.character.lockmovementendtick=executiontime+self.duration
end


function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick:OnBuffEnd()	
	TRAININGGROUNDS_Buff.OnBuffEnd(self)
	
	if(self.combat.flyingserpentkick.button~=nil)then
		self.combat.flyingserpentkick.button.frame.texture:SetTexture(self.combat.flyingserpentkick.icon)
	end	
	--self.combat.character:SetAnimationByIndex(706,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,750,false,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE,300)
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick:step()
	--if(self.combat.character.environment.currenttime>=self.starttime+200)then
	--if(self.combat.character.environment.currenttime>=self.starttime+300)then
	if(self.combat.character.environment.currenttime>=self.starttime+100)then
		if(self.combat.character.z<=0)then
			local speed=4.10
			-- TODO: change "currentfacing" so it works with standard radians
			--	(SetFacing remains locked to WoW radians, nothing we can do about that)
			self.combat.character.xspeed=self.rollxx*speed*TRAININGGROUNDS_Game.TEMP_MOVESPEED
			self.combat.character.yspeed=self.rollyy*speed*TRAININGGROUNDS_Game.TEMP_MOVESPEED
		end		
	end
end