--TODO: just rename/move to TouchOfDeath

TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TouchOfDeathDeathArtGaleBurst = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Buff)

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TouchOfDeathDeathArtGaleBurst:setCustomBuffInfo(combat)
	TRAININGGROUNDS_Buff.setCustomBuffInfo(self,combat)
	self.duration=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TouchOfDeath.DURATION
	--self.icon="Interface\\Icons\\ability_monk_tigerslust"
	
	-- to get galeburst damage, multiply totaldamage by 0.1
	-- it does not include touchofdeath's player's maxHP damage
	self.totaldamage=0
	self.enemyplayer=nil
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TouchOfDeathDeathArtGaleBurst:OnBuffStart()
	self.combat.hp.usefill2=true	
	self.combat:RevealNameplateHP()
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TouchOfDeathDeathArtGaleBurst:step(elapsed,currenttime)
	TRAININGGROUNDS_Buff.step(self,elapsed,currenttime)
	--TODO: spell:GetToDDamage	
	local fill2value=self.spell.toddamage+self.totaldamage*0.1
	if(fill2value>self.combat.hp.value)then
		fill2value=self.combat.hp.value
	end
	self.combat.hp:SetFill2Value(fill2value)
	
end



-- movement speed is currently handled in Environment_World
-- don't try this at home

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TouchOfDeathDeathArtGaleBurst:OnOwnerRecordDamage(damage,damagecharacter,damagespell,damagetime)
	TRAININGGROUNDS_Buff.OnOwnerRecordDamage(self,damage,enemycharacter,damagespell,damagetime)
	if(damagespell~=nil)then
		--print("Gale Burst spellname ",damagespell.spellname)
	end
	if(damagespell==nil or damagespell.spellname~="Touch of Death")then	
		--print("Gale Burst add damage",damage*0.1)
		self.totaldamage=self.totaldamage+damage	
	end
	
	
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TouchOfDeathDeathArtGaleBurst:OnOwnerDie(damagetime)	
	--print(self.expirytime,damagetime)

	if(self.expirytime>damagetime)then
		if(self.enemyplayer~=nil)then
			local tod=self.enemyplayer.combat.touchofdeath
			if(tod~=nil)then				
				tod.offcooldowntick=tod.offcooldowntick-tod.defaultcooldown*(0.6)
				tod.naturaloffcooldowntick=tod.naturaloffcooldowntick-tod.defaultcooldown*(0.6)
				--TODO: find out if there's a way to draw this without setting the cooldown sweep back to 100%
				tod.combat:DrawOneCooldown(tod,damagetime)								
				--TODO: dispel effect that causes take ToD damage + particle effect
					--(at the moment it's part of the spell, so there's no buff to dispel)
			end
		end
	end
	
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TouchOfDeathDeathArtGaleBurst:OnBuffEnd(endtime)	
	--print("Gale Burst total damage: ",self.totaldamage*0.1)
	
	local buff
	buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_VisualTouchOfDeath.new()
	buff:setup(self.combat,endtime)
	
	local icon=TRAININGGROUNDS_Particle_TouchOfDeathIcon.new()
	icon:setup(self.combat.character.environment)
	-- icon.modelframe:SetModel("SPELLS\Monk_TouchofDeath_Impact.M2")
	-- icon.modelframe:SetWidth(300)
	-- icon.modelframe:SetHeight(300)
	icon.x=self.combat.character.x
	icon.y=self.combat.character.y-1
	icon.z=0
	icon.gravity=0
	icon.expirytime=endtime+1000
	
	local totaltoddamage=self.spell.toddamage+self.totaldamage*0.1;
	self.enemyplayer.combat:ApplyExactDamageToEnemy(totaltoddamage,self.combat.character,self.spell)			
	self.combat.character:TouchOfDeathStagger()
	
	self.combat.hp.usefill2=false
end