
TRAININGGROUNDS_CombatModule_IllusionaryGuardian = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule)

function TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk:setup(character)
	TRAININGGROUNDS_CombatModule.setup(self,character)
	
	--self.ai=TRAININGGROUNDS_CombatAI_W7_WindwalkerMonk.new()
	--self.ai:setup(self)
	
	-- AI is handled via IllusionaryGuardian:step
end


function TRAININGGROUNDS_CombatModule_IllusionaryGuardian:SetSpells()	
	self.defend=TRAININGGROUNDS_Spell_Enemy_ProvingGrounds_Defend.new()
	self.defend:setup(self)
	tinsert(self.spellbook,self.defend)
end



function TRAININGGROUNDS_CombatModule_IllusionaryGuardian:CreateSpellButtons()
	self:ClearAllSpellButtons()
	self:CreateActionBar()
	
	local spellbutton
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.defend,self.actionbar,"1",false,false)
	tinsert(self.spellbuttons,spellbutton)

end

function TRAININGGROUNDS_CombatModule_IllusionaryGuardian:RollToBlock(attackingenemy)
	--print("RollToBlock")
	local defend=self:GetBuffIfExists(TRAININGGROUNDS_Buff_Enemy_ProvingGrounds_Defend)
	if(defend~=nil)then
		--print("defend exists")
		--check facing
		local facing1=self.character.currentfacing-math.pi/2
		local facing2=math.atan2(self.character.y-attackingenemy.y,self.character.x-attackingenemy.x)
		if(facing1<0)then facing1=facing1+math.pi*2 end ; if(facing1>math.pi*2)then facing1=facing1-math.pi*2 end
		if(facing2<0)then facing2=facing2+math.pi*2 end ; if(facing2>math.pi*2)then facing2=facing2-math.pi*2 end
		--SOURCE: stackoverflow.com/questions/1878907/the-smallest-difference-between-2-angles
		--local diff=math.abs(atan2(sin(facing1-facing2),cos(facing1-facing2)))
		local mod=function(a,n) return a-math.floor(a/n)*n end
		local a=facing1-facing2
		local diff=mod((a+math.pi),math.pi*2)-math.pi
		
		--print("RollToBlock difference: ",diff)
		if(math.abs(diff)>math.pi/2)then
			if(_TRAININGGROUNDS.debug_guardianshield_troubleshoot==true)then
				print("Guardian facing (real radians): ",facing1)
				print("Your facing: ",facing2)
				print("Difference: ",diff)
			end
	
			return true				
		end
	end
	--print("defend does not exist")
	return false
end