TRAININGGROUNDS_Spell_W7_WindwalkerMonk_EnergizingElixir = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_EnergizingElixir:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Energizing Elixir"
	self.shortspellname="EE"
	
	--self.animationsequence=61
	--self.animationlength=3000
	self.animationname="EatWhileStanding"
	
	self.usesgcd=false
	self.range=nil
	self.requirestarget=false
	
	self.defaultcooldown=60000
	
	self.icon="Interface\\Icons\\ability_monk_energizingwine"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_EnergizingElixir:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	
	self.combat.energy:AddToValue(200)
	self.combat.chi:AddToValue(10)
	
	local buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_VisualMainhandBrew.new()
	buff:setup(self.combat,executespelltick)
	
			
end
