TRAININGGROUNDS_Spell_W7_WindwalkerMonk_InvokeXuenTheWhiteTiger = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)
	


function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_InvokeXuenTheWhiteTiger:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Invoke Xuen, the White Tiger"
	self.shortspellname="Xuen"
	
	self.animationname="FinishUndirectedSpellcast"
	
	self.usesgcd=false
	
	self.range=nil

	self.defaultcooldown=180000
	
	self.icon="Interface\\Icons\\ability_monk_summontigerstatue"
	
	self.xuen=nil
	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_InvokeXuenTheWhiteTiger:ApplyExecutedSpellSideEffects(currenttime)
	local xuen=TRAININGGROUNDS_Xuen.new()
	xuen:setup(self.combat.character.environment)
	xuen.spell=self
	xuen.owner=self.combat.character
	--print("?",self.combat.target)
	tinsert(xuen.owner.combat.pets,xuen)
	xuen.x,xuen.y=xuen:GetMoveLocation(self.combat.target)
	xuen.expirytime=currenttime+45000
	self.xuen=xuen	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_InvokeXuenTheWhiteTiger:executeDespiteCooldown(currenttime)
	if(self.xuen~=nil)then
		self.xuen.copyownerstarget=(not self.xuen.copyownerstarget)
		if(self.xuen.copyownerstarget==true)then
			-- don't use AcquireNewTarget -- in this specific case, we want xuen to change target to nil if owner's target is nil,
				-- and acquirenewtarget won't do that
			self.xuen.combat:ChangeTarget(self.combat.target)
			self.combat.character.environment.game:createSpellTextbox("(Xuen: Assist)")
		else
			self.xuen:AcquireNewTarget()
			self.combat.character.environment.game:createSpellTextbox("(Xuen: Seek)")
		end
		return true
	end
	return false
end
