TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Roll = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Roll:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Roll"
	self.shortspellname="R"
	
	self.defaultcooldown=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll.ROLLDURATION
	self.defaultrecharge=20000	
	--self.maxcharges=2		-- now 2, down from 3, with revised artifact talents
	self.maxcharges=1		-- now 1
	--TODO: maybe make this the default behavior
	self.onlyshowrechargenevercooldown=true
	
	self.animationsequence=nil
	
	self.range=nil
	self.requirestarget=false
	self.usesgcd=false		
	
	self.queueable=false

	self.icon="Interface\\Icons\\ability_monk_roll"
	
	self.visibletostatistics=false
end


function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Roll:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	
	local buff
	buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll.new()
	buff:setup(self.combat,executespelltick)
	
end

