TRAININGGROUNDS_ScenarioController_Tutorial = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_ScenarioController)

function TRAININGGROUNDS_ScenarioController_Tutorial:SetCustomInfo()
	TRAININGGROUNDS_ScenarioController.SetCustomInfo(self)
	
	self.ysortable=false
	
	self.states={}
	
	local i=0
	i=i+1;self.states.SETUP=i
	i=i+1;self.states.WAIT=i
	i=i+1;self.states.WELCOME=i
	i=i+1;self.states.SPAWNPLAYER=i
	i=i+1;self.states.WAVE=i
	i=i+1;self.states.SPAWNCRITTERS=i
	i=i+1;self.states.ZOOMOUT=i	
	i=i+1;self.states.WASD=i
	i=i+1;self.states.LMBRMB=i
	i=i+1;self.states.LMBTARGET=i
	i=i+1;self.states.PRESS1ATTACK=i
	i=i+1;self.states.MOUSEWHEELZOOM=i
	i=i+1;self.states.PGUPPGDNZOOM=i
	i=i+1;self.states.WAITFORZOOM=i
	i=i+1;self.states.WAITFORRABBIT=i
	i=i+1;self.states.SPEEDBOOST=i
	i=i+1;self.states.PRESS8ROLL=i
	i=i+1;self.states.WAITFORSPEEDBOOST=i
	i=i+1;self.states.WAITFORRABBITCLEAR=i
	i=i+1;self.states.WAITFORALLCLEAR=i
	i=i+1;self.states.WAITBEFORESETUPPHASE2=i
	i=i+1;self.states.SETUPPHASE2=i
	i=i+1;self.states.BIGVIRMENROAR=i
	i=i+1;self.states.KNOCKDOWN=i
	i=i+1;self.states.SPAWNMINIONS=i
	i=i+1;self.states.TIGERPALM=i
	i=i+1;self.states.WAITFORTIGERPALM=i
	i=i+1;self.states.FISTSOFFURY=i
	i=i+1;self.states.WAITFORFISTSOFFURY=i
	i=i+1;self.states.STRIKEOFTHEWINDLORD=i
	i=i+1;self.states.WAITFORSTRIKEOFTHEWINDLORD=i
	i=i+1;self.states.HIGHPRIORITY=i
	i=i+1;self.states.RISINGSUNKICK=i
	i=i+1;self.states.WAITFORRISINGSUNKICK=i
	i=i+1;self.states.MEDIUMPRIORITY=i
	i=i+1;self.states.COREROTATION=i
	i=i+1;self.states.ATTHISPOINT=i
	i=i+1;self.states.ADVANCEDTECHNIQUES=i
	i=i+1;self.states.BLACKOUTKICK=i
	i=i+1;self.states.SPINNINGCRANEKICK=i
	i=i+1;self.states.WAITFORWEAKKICK=i
	i=i+1;self.states.LOWPRIORITY=i
	i=i+1;self.states.TIGEREYEBREW=i
	i=i+1;self.states.WAITFORTIGEREYEBREW=i
	i=i+1;self.states.ROLL=i
	i=i+1;self.states.FLYINGSERPENTKICK=i
	i=i+1;self.states.WAITFORFLYINGSERPENTKICK=i
	i=i+1;self.states.RUNAWAY=i
	i=i+1;self.states.TOUCHOFDEATH=i
	i=i+1;self.states.WAITFORTOUCHOFDEATH=i
	i=i+1;self.states.WAITFORVERMINCLEAR=i	
	i=i+1;self.states.CONCLUSION=i
	i=i+1;self.states.UNLOCK=i
	i=i+1;self.states.END=i

	self.state=nil
	self.nextstate=self.states.SETUP
	self.statetimer=0
	
	self.critters={}
	self.rabbit=nil
	self.bigvirmen=nil
	self.virmen={}
	self.virmenrespawntime={}
	self.nextminionspawntime=0
	self.nextminionspawnframecount=0
	
	
end

function TRAININGGROUNDS_ScenarioController_Tutorial:step(elapsed)
	TRAININGGROUNDS_ScenarioController.step(self,elapsed)
	
	local currenttime=self.environment.currenttime
	

	
	if(self.statetimer~=nil)then
		if(self.mostrecenttypewriter==nil
			or (self.mostrecenttypewriter.letterindex>=#self.mostrecenttypewriter.targetmessage)
			or self.mostrecenttypewriter.dontlock==true
			or self.mostrecenttypewriter.dead==true)then
			self.statetimer=self.statetimer-elapsed*1000
		end
		--print(self.statetimer)
		if(self.statetimer<=0)then	
			self.statetimer=0
			self.state=self.nextstate
		
			if(self.state==self.states.SETUP)then
				local arenaborder=TRAININGGROUNDS_ArenaBorder.new()
				arenaborder:setup(self.environment)	
				arenaborder.frame.framelevel=1
				arenaborder.frame:SetFrameLevel(arenaborder.frame.framelevel)
				self.environment:ResetCamera()
				self.statetimer=0
				self.nextstate=self.states.WAIT	
			elseif(self.state==self.states.WAIT)then							
				self.statetimer=1000
				self.nextstate=self.states.WELCOME
			elseif(self.state==self.states.WELCOME)then			
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Welcome to TrainingGrounds.",5000)				
				self.statetimer=1000
				self.nextstate=self.states.SPAWNPLAYER				
			elseif(self.state==self.states.SPAWNPLAYER)then		
				self.player=TRAININGGROUNDS_PlayerCharacter.new()
				self.environment.player=self.player
				self.player:setup(self.environment)
				self.player.x=0;self.player.y=0
				self.player.z=300
				self.player:SetAdjustedFacing(0)
				self.player.combat=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.new()
				self.player.combat:setup(self.player)
				--self.player.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP)
				self.player.combat:CreateTutorialSpellButtons(1)				
				self.player.combat:CreateVisibleFrames()	--channelbar
				local buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new()
				buff:setup(self.player.combat,currenttime); self.player.modelframe:SetAlpha(0)
				self.environment.camera:ChangeFocus(self.player)
				if(_TRAININGGROUNDS.debug_autoscenario~=true)then
					--local buff=TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence.new()
					--buff:setup(self.player.combat,currenttime)
					--self.player.lockmovementendtick=currenttime+TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION-2500
					--self.player.lockfacingendtick=currenttime+TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION-2500					
					self.player.lockmovementendtick=currenttime+TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION
					self.player.lockfacingendtick=currenttime+TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION					
				end
				
				self.player.crittercount=6
				--TODO: delay only as long as wave animation lasts
				self.statetimer=TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence_DURATION-2500										
				self.nextstate=self.states.WAVE
			elseif(self.state==self.states.WAVE)then
				self.player:SetAnimationByName("Wave")
				self.statetimer=2500
				self.nextstate=self.states.SPAWNCRITTERS
			elseif(self.state==self.states.SPAWNCRITTERS)then				
				--!!!
				local critter=TRAININGGROUNDS_Enemy_Tutorial_Critter_Marmot.new()
				critter:setup(self.environment);critter.x=300;critter.y=300;critter:SetAdjustedFacing(math.random()*6.28)				
				tinsert(self.critters,critter)
				local critter=TRAININGGROUNDS_Enemy_Tutorial_Critter_Marmot.new()
				critter:setup(self.environment);critter.x=-300;critter.y=-300;critter:SetAdjustedFacing(math.random()*6.28)
				tinsert(self.critters,critter)
				local critter=TRAININGGROUNDS_Enemy_Tutorial_Critter_Squirrel.new()
				critter:setup(self.environment);critter.x=-300;critter.y=300;critter:SetAdjustedFacing(math.random()*6.28)
				tinsert(self.critters,critter)
				local critter=TRAININGGROUNDS_Enemy_Tutorial_Critter_Squirrel.new()
				--local critter=TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen.new()
				critter:setup(self.environment);critter.x=300;critter.y=-300;critter:SetAdjustedFacing(math.random()*6.28)
				tinsert(self.critters,critter)
				local critter=TRAININGGROUNDS_Enemy_Tutorial_Critter_Rat.new()
				--critter:setup(self.environment);critter.x=700;critter.y=0;critter.airadius=critter.x
				critter:setup(self.environment);critter.x=500;critter.y=0;critter.airadius=critter.x
				tinsert(self.critters,critter)
				local critter=TRAININGGROUNDS_Enemy_Tutorial_Critter_Rabbit.new()
				critter:setup(self.environment);critter.x=0;critter.y=800;critter.airadius=critter.y
				tinsert(self.critters,critter)
				self.rabbit=critter
				self.statetimer=0
				self.nextstate=self.states.ZOOMOUT
			elseif(self.state==self.states.ZOOMOUT)then
				self.environment.camera.targetzoom=1
				--self.statetimer=1500
				self.statetimer=500
				self.nextstate=self.states.WASD								
				--!!!
				--self.nextstate=self.states.SPEEDBOOST	 	-- works
				--self.nextstate=self.states.LMBTARGET	 	-- doesn't work
				--self.nextstate=self.states.WAITFORRABBIT	-- almost works -- invisible targeting circle
				
			elseif(self.state==self.states.WASD)then
				self.statetimer=nil
				self.nextstate=self.states.LMBRMB
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Use |cFFFFFF00WASD|cFFFFFFFF to move.")
			elseif(self.state==self.states.LMBRMB)then				
				--self.mostrecenttypewriter.postexpirytime=1000
				self.statetimer=nil
				--self.nextstate=self.states.ZOOMOUT
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(You can also move by pressing |cFFFFFF00LEFT MOUSE BUTTON|cFFFFFFFF")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
				tm:CenterInUI(); tm.speedmultiplier=3
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00+ RIGHT MOUSE BUTTON|cFFFFFFFF simultaneously.) ")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
				tm:CenterInUI(); tm.speedmultiplier=3
				self.statetimer=3000
				self.nextstate=self.states.LMBTARGET				
			elseif(self.state==self.states.LMBTARGET)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")--;tm.speedmultiplier=0.1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")--;tm.speedmultiplier=0.1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")--;tm.speedmultiplier=0.1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")--;tm.speedmultiplier=0.1
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00LEFT-CLICK|cFFFFFFFF NPCs to target them.")				
				self.statetimer=nil
				self.nextstate=self.states.PRESS1ATTACK
			elseif(self.state==self.states.PRESS1ATTACK)then				
				self.environment.player.combat:CreateTutorialSpellButtons(2)
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Press |cFFFFFF001|cFFFFFFFF to attack.")
				self.statetimer=nil
				self.nextstate=self.states.MOUSEWHEELZOOM
			elseif(self.state==self.states.MOUSEWHEELZOOM)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Use |cFFFFFF00SCROLL WHEEL|cFFFFFFFF to adjust the camera.")
				self.statetimer=2000				
				self.nextstate=self.states.PGUPPGDNZOOM
			elseif(self.state==self.states.PGUPPGDNZOOM)then				
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(You can also use the |cFFFFFF00HOME|cFFFFFFFF and |cFFFFFF00END|cFFFFFFFF keys.)")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
				tm:CenterInUI(); tm.speedmultiplier=3	
				self.statetimer=3000
				self.nextstate=self.states.WAITFORZOOM
			elseif(self.state==self.states.WAITFORZOOM)then
				self.statetimer=nil
				self.nextstate=self.states.WAITFORRABBIT			
			elseif(self.state==self.states.WAITFORRABBIT)then				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")	
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")				
				self.statetimer=nil
				self.nextstate=self.states.SPEEDBOOST				
			elseif(self.state==self.states.SPEEDBOOST)then
				self.environment.player.combat:CreateTutorialSpellButtons(3)
				-- maybe wait for player to target the rabbit
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"To move quickly,")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"press |cFFFFFF00R|cFFFFFFFF to use your temporary speed boost,")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"or press |cFFFFFF00MIDDLE MOUSE BUTTON|cFFFFFFFF to roll.")
				self.statetimer=3000
				self.nextstate=self.states.PRESS8ROLL
			elseif(self.state==self.states.PRESS8ROLL)then
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(You can also roll by pressing |cFFFFFF008|cFFFFFFFF.)")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
				tm:CenterInUI(); tm.speedmultiplier=3	
				self.statetimer=2000
				self.nextstate=self.states.WAITFORRABBITCLEAR
			elseif(self.state==self.states.WAITFORRABBITCLEAR)then
				self.statetimer=nil
				self.nextstate=self.states.WAITFORALLCLEAR
			elseif(self.state==self.states.WAITFORALLCLEAR)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")	
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				self.statetimer=nil
				self.nextstate=self.states.WAITBEFORESETUPPHASE2
			elseif(self.state==self.states.WAITBEFORESETUPPHASE2)then
				-- 2 second wait for the last critter to fade out
				self.statetimer=2000
				self.nextstate=self.states.SETUPPHASE2
			elseif(self.state==self.states.SETUPPHASE2)then
			
				self.player.combat:CreateTutorialSpellButtons(4)
			
				local i
				for i=1,#self.critters,1 do
					self.critters[i]:die()
				end
				self.critters={}
				self.rabbit=nil				
				
				local bigvirmen=TRAININGGROUNDS_Enemy_Tutorial_HugeVirmen.new()
				bigvirmen:setup(self.environment);bigvirmen.x=0;bigvirmen.y=0;
				bigvirmen.combat=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.new();bigvirmen.combat:setup(bigvirmen)
				local buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new()
				buff:setup(bigvirmen.combat,currenttime);	bigvirmen.modelframe:SetAlpha(0)
				self.bigvirmen=bigvirmen
				self.bigvirmen.z=300
				self.environment.camera:ChangeFocus(bigvirmen)
				self.remembertargetzoom=self.environment.camera.targetzoom
				self.environment.camera.targetzoom=1
				
				--virmen roar: 55
				-- duration: 1500 (but we use 1200)
				
				--TODO: this line is related to the disappearing virmen problem; current priority!
				--self.player.combat:CreateTutorialSpellButtons(4)
				
				self.statetimer=nil
				self.nextstate=self.states.KNOCKDOWN	
			elseif(self.state==self.states.KNOCKDOWN)then
				--TODO: this breaks if player is at exactly (0,0)
				local facingangle=math.atan2(self.player.x,-self.player.y)+math.pi
				self.player.currentfacing=facingangle
				self.player.modelframe:SetFacing(facingangle)
				self.player.lockmovementendtick=currenttime+5000
				self.player.lockfacingendtick=currenttime+5000
				local moveangle=math.atan2(self.player.y,self.player.x)
				self.player.xspeed=math.cos(moveangle)*500
				self.player.yspeed=math.sin(moveangle)*500
				--TODO: the midair knockdown looks awkward for a few character models
				self.player.zspeed=500
				self.player:SetAnimationByName("Knockdown")
				self.nextstate=self.states.BIGVIRMENROAR
				self.statetimer=800
				--TODO: knock back player, spawn virmen
			elseif(self.state==self.states.BIGVIRMENROAR)then
				-- local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"- Windwalker Monk Basic Techniques -",3000)
				-- tm.dontlock=true

				self.bigvirmen:SetAnimationByIndex(55,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,1200)
				
				--print("!!!", currenttime)
				--self.bigvirmen.modelframe:SetAnimation(self.bigvirmen.attackanimation)
				self.statetimer=1200
				self.nextstate=self.states.SPAWNMINIONS

			elseif(self.state==self.states.SPAWNMINIONS)then
				-- The game doesn't like to spawn more than ~7 enemies at once
				-- so we have to bring them in one frame at a time in a later part of the function
				-- for now, just reserve their places  (this isn't strictly necessary)
				for i=1,8,1 do										
					self.virmen[i]=nil		
					self.virmenrespawntime[i]=0
					--print("!!!",i)
				end
			
				self.statetimer=3800				
				self.nextstate=self.states.TIGERPALM
			elseif(self.state==self.states.TIGERPALM)then
				--self.bigvirmen.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP/2)
				self.bigvirmen.combat.hp.regenrate=250*1.5
				self.environment.camera:ChangeFocus(self.player)
				if(self.remembertargetzoom~=nil)then
					self.environment.camera.targetzoom=self.remembertargetzoom
				end
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"- Windwalker Monk Basic Techniques -",3000)
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF001: Tiger Palm |cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Chi generator|cFFFFFFFF ability. ")								
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"You use Chi to pay for your other abilities.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Tiger Palm costs Energy.  (The only use for Energy is Tiger Palm.)")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1					
				self.statetimer=nil
				self.environment.player.combat:CreateTutorialSpellButtons(5) -- Tiger Palm
				self.player.combat.energy:setValue(130)		
				self.statetimer=3000
				self.nextstate=self.states.WAITFORTIGERPALM
			elseif(self.state==self.states.WAITFORTIGERPALM)then
				self.statetimer=1	--nil	--!!!
				self.nextstate=self.states.FISTSOFFURY
			elseif(self.state==self.states.FISTSOFFURY)then				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF002: Fists of Fury |cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Very strong|cFFFFFFFF attack.  Costs 3 Chi.")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Use as often as possible.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Can be |cFFFFFF00channeled while moving|cFFFFFFFF,")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1					
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"but you should |cFFFFFF00never interrupt the channel|cFFFFFFFF with a different attack.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1					
				
				self.statetimer=nil
				self.environment.player.combat:CreateTutorialSpellButtons(6) -- FoF
				self.statetimer=3000
				self.nextstate=self.states.WAITFORFISTSOFFURY
			elseif(self.state==self.states.WAITFORFISTSOFFURY)then
				self.statetimer=1	--nil	--!!!
				self.nextstate=self.states.STRIKEOFTHEWINDLORD	
			elseif(self.state==self.states.STRIKEOFTHEWINDLORD)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Shift+1: Strike of the Windlord |cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Very strong|cFFFFFFFF attack.  Costs 3 Chi.")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Use as often as possible.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")			
				self.statetimer=nil
				self.environment.player.combat:CreateTutorialSpellButtons(7) -- SotW
				self.statetimer=3000
				self.nextstate=self.states.WAITFORSTRIKEOFTHEWINDLORD
			elseif(self.state==self.states.WAITFORSTRIKEOFTHEWINDLORD)then
				self.statetimer=1	--nil	--!!!
				self.nextstate=self.states.HIGHPRIORITY
			elseif(self.state==self.states.HIGHPRIORITY)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Fists of Fury is more effective against |cFFFFFF001-2 targets|cFFFFFFFF ")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," and Strike of the Windlord is more effective against |cFFFFFF003+ targets|cFFFFFFFF. ")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Regardless, |cFFFFFF00both|cFFFFFFFF of these attacks have |cFFFFFF00high priority|cFFFFFFFF. ")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Make sure you have |cFFFFFF00enough Chi|cFFFFFFFF to use them")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"by the time they become available.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1				
				
				self.statetimer=5000
				self.nextstate=self.states.RISINGSUNKICK
			elseif(self.state==self.states.RISINGSUNKICK)then
				self.environment.player.combat:CreateTutorialSpellButtons(8) -- RSK
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF003: Rising Sun Kick|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Moderate|cFFFFFFFF attack.  Costs 2 Chi. ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Hits 1 target.")
				self.statetimer=3000
				self.nextstate=self.states.WAITFORRISINGSUNKICK
			elseif(self.state==self.states.WAITFORRISINGSUNKICK)then
				self.statetimer=1--!!!
				self.nextstate=self.states.MEDIUMPRIORITY
			elseif(self.state==self.states.MEDIUMPRIORITY)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")			
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Rising Sun Kick has |cFFFFFF00medium priority|cFFFFFFFF.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Use it when your high priority attacks are |cFFFFFF00on cooldown|cFFFFFFFF.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1				
				self.statetimer=5000
				self.nextstate=self.states.COREROTATION
			elseif(self.state==self.states.COREROTATION)then				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Tiger Palm|cFFFFFFFF, |cFFFFFF00Fists of Fury|cFFFFFFFF, |cFFFFFF00Strike of the Windlord|cFFFFFFFF, and |cFFFFFF00Rising Sun Kick|cFFFFFFFF... ")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"These four abilities make up your |cFFFFFF00core rotation|cFFFFFFFF.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1								
				self.statetimer=5000
				self.nextstate=self.states.ATTHISPOINT
			elseif(self.state==self.states.ATTHISPOINT)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(At this point, we'd normally give you a few minutes to practice,")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"then take you back to the world map when you're done.")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"However, in this preview demo, we're going to rush ahead")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"and unlock all of your abilities right now.)")
				tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				self.statetimer=5000
				self.nextstate=self.states.ADVANCEDTECHNIQUES
			elseif(self.state==self.states.ADVANCEDTECHNIQUES)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"- Windwalker Monk Advanced Techniques -")
				self.statetimer=3000
				self.nextstate=self.states.BLACKOUTKICK
			elseif(self.state==self.states.BLACKOUTKICK)then				
				self.environment.player.combat:CreateTutorialSpellButtons(9) -- BoK
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF004: Blackout Kick|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Weak |cFFFFFF00singletarget|cFFFFFFFF attack.  Costs 1 Chi. ")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Best used against |cFFFFFF001-2 targets|cFFFFFFFF. ");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				self.statetimer=3000
				self.nextstate=self.states.SPINNINGCRANEKICK
			elseif(self.state==self.states.SPINNINGCRANEKICK)then				
				self.environment.player.combat:CreateTutorialSpellButtons(10) -- SCK
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Shift+4: Spinning Crane Kick|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Weak |cFFFFFF00area of effect|cFFFFFFFF attack.  Costs 1 Chi. ")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Best used against |cFFFFFF003+ targets|cFFFFFFFF. ");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				self.statetimer=5000
				self.nextstate=self.states.WAITFORWEAKKICK
			elseif(self.state==self.states.WAITFORWEAKKICK)then	
				self.statetimer=1	--!!!
				self.nextstate=self.states.LOWPRIORITY
			elseif(self.state==self.states.LOWPRIORITY)then				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"These attacks are |cFFFFFF00very weak|cFFFFFFFF.");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"You shouldn't use them |cFFFFFF00unless|cFFFFFFFF you can");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00still afford your stronger attacks|cFFFFFFFF when they become available. ");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1			
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," By the way, if the Blackout Kick button ever |cFFFFFF00lights up|cFFFFFFFF, ");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," that means your next use is |cFFFFFF00free|cFFFFFFFF... ");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," but even then, it's still |cFFFFFF00low priority|cFFFFFFFF compared to your stronger attacks. ");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=1

				self.statetimer=5000
				self.nextstate=self.states.TIGEREYEBREW
			elseif(self.state==self.states.TIGEREYEBREW)then					
				self.environment.player.combat:CreateTutorialSpellButtons(11) -- TEB
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF006: Tigereye Brew|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF00Temporarily increases damage dealt|cFFFFFFFF by 30%. ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Use when your |cFFFFFF00strongest abilities|cFFFFFFFF are available. ")
				self.statetimer=5000
				self.nextstate=self.states.WAITFORTIGEREYEBREW
			elseif(self.state==self.states.WAITFORTIGEREYEBREW)then
				self.statetimer=1	--!!!
				self.nextstate=self.states.ROLL
			elseif(self.state==self.states.ROLL)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF008: Roll|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(Remember, you can also use |cFFFFFF00MIDDLE MOUSE BUTTON|cFFFFFFFF to roll.)");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=3				
				self.statetimer=3000
				self.nextstate=self.states.FLYINGSERPENTKICK
			elseif(self.state==self.states.FLYINGSERPENTKICK)then	
				self.environment.player.combat:CreateTutorialSpellButtons(12) -- FSK
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF009: Flying Serpent Kick|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Sends you flying forward |cFFFFFF00very quickly|cFFFFFFFF.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"Press the key again to |cFFFFFF00stop|cFFFFFFFF and |cFFFFFF00slam into the ground|cFFFFFFFF.")
				self.statetimer=3000
				self.nextstate=self.states.WAITFORFLYINGSERPENTKICK				
			elseif(self.state==self.states.WAITFORFLYINGSERPENTKICK)then					
				self.statetimer=nil	--!!!
				self.nextstate=self.states.RUNAWAY				
			elseif(self.state==self.states.RUNAWAY)then
				self.statetimer=1	--!!!
				self.nextstate=self.states.TOUCHOFDEATH				
			elseif(self.state==self.states.TOUCHOFDEATH)then						
				self.environment.player.combat:CreateTutorialSpellButtons(13) -- ToD
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," |cFFFFFF007: Touch of Death|cFFFFFFFF ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Deals |cFFFFFF00overwhelming|cFFFFFFFF damage after 8 seconds. ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," (This damage |cFFFFFF00isn't affected by temporary buffs|cFFFFFFFF.) ")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," If you |cFFFFFF00finish off an enemy|cFFFFFFFF with Touch of Death,")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," the cooldown is |cFFFFFF00reduced|cFFFFFFFF.")				
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self," Use as often as possible, especially on |cFFFFFF00priority targets|cFFFFFFFF.")
				self.statetimer=5000
				self.nextstate=self.states.WAITFORTOUCHOFDEATH
			elseif(self.state==self.states.WAITFORTOUCHOFDEATH)then							
				self.statetimer=1--!!!
				self.nextstate=self.states.WAITFORVERMINCLEAR--!!!
			elseif(self.state==self.states.WAITFORVERMINCLEAR)then							
				self.statetimer=1--!!!
				self.nextstate=self.states.CONCLUSION--!!!
			elseif(self.state==self.states.CONCLUSION)then	
				TRAININGGROUNDS_VARS.progress=2
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"You now have all of the |cFFFFFF00baseline offensive techniques|cFFFFFFFF.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|PAUSE")
				local tm=TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"(...well...  all except one.  We're still working on it.  It's tricky.)");tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE"); tm:CenterInUI(); tm.speedmultiplier=3
				self.statetimer=5000
				self.nextstate=self.states.UNLOCK
			elseif(self.state==self.states.UNLOCK)then		
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"The next two stages have been unlocked.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"You'll be able to set your |cFFFFFF00talents|cFFFFFFFF and |cFFFFFF00haste rating|cFFFFFFFF.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"See you there!")
				self.statetimer=3000
				self.nextstate=self.states.END
				--!!!
			end
			--self.environment.player.combat:CreateTutorialSpellButtons(3)
			--
		end
	end
	
	--TODO: if player is targeting the rabbit and hasn't cleared the "attack something" phase,
	--	give them a hint to attack something else
	--		(or tell them to press TAB to change targets?)
	
	-- --!!!
	-- if(self.virmen[1]~=nil)then
		-- self.virmen[1].frame:Show()
		-- self.virmen[1].modelframe:Show()	
		-- print(self.virmen[1].frame:GetAlpha(),self.virmen[1].modelframe:GetAlpha())
		-- print(self.virmen[1].frame:GetPoint(1),self.virmen[1].modelframe:GetPoint(1))

	-- end
	
	--TODO: debug skip
	if(_TRAININGGROUNDS.debug_autoscenario==true)then
		--if(self.state<self.states.PRESS1ATTACK)then
		--if(self.state<self.states.WAITFORZOOM)then
		--if(self.state<self.states.PRESS8ROLL)then
		-- if(self.state<self.states.SETUPPHASE2)then
			-- if(self.player~=nil)then
				-- self.player.x=0;self.player.y=0
			-- end
			-- self.statetimer=0
		-- end
		if(self.player~=nil and self.nextstate<self.states.SPAWNMINIONS)then		
			self.nextstate=self.states.SPAWNMINIONS
		end
		if(self.player~=nil and self.nextstate<self.states.WAITFORFLYINGSERPENTKICK)then
			self.statetimer=0
		end		
	end
	
	if(self.state<self.states.ZOOMOUT)then
		self.environment.camera.targetzoom=1.5
		self.environment.camera.zoom=self.environment.camera.targetzoom
	end
	
	if(self.state>=self.states.SETUPPHASE2 and self.state<=self.states.SPAWNMINIONS)then
		self.environment.camera.targetzoom=1
		-- we don't yet have a way to make the player jump back then stop,
		-- so stop them manually
		if(self.player.z<=0 and self.player.zspeed<=0)then
			self.player.xspeed=0
			self.player.yspeed=0
		end
	end
	
	if(self.state==self.states.WASD)then
		if(self.player~=nil)then
			if(self.player.x~=0 or self.player.y~=0)then
				self.statetimer=0
			end
		end
	elseif(self.state==self.states.LMBTARGET)then
		if(self.player~=nil and self.player.combat~=nil)then
			if(self.player.combat.targetchangecount>0)then
				self.statetimer=0
			end
		end
	elseif(self.state==self.states.PRESS1ATTACK)then
		if(self.player~=nil and self.player.combat~=nil)then
			if(self.player.combat.totalspellusecount>0)then
				self.statetimer=0
			end
		end
	elseif(self.state==self.states.WAITFORZOOM)then
		if(self.environment.camera~=nil and self.environment.camera.targetzoom~=1)then
			self.statetimer=0
		end
	elseif(self.state==self.states.WAITFORRABBIT)then
		if(self.rabbit.deadingame==true
		or (self.player~=nil and self.player.combat.target==self.rabbit)
		)then
			self.statetimer=0			
		end
	elseif(self.state==self.states.WAITFORRABBITCLEAR)then
		if(self.rabbit~=nil and self.rabbit.deadingame==true)then		
			self.statetimer=0
			self.rabbit=nil
		end		
	elseif(self.state==self.states.WAITFORALLCLEAR)then
		if(self.player~=nil and self.player.crittercount<=0)then		
			--print("Self.player.crittercount is ",self.player.crittercount)
			self.statetimer=0
		end
	elseif(self.state==self.states.SETUPPHASE2)then
		if(self.bigvirmen~=nil and self.bigvirmen.z<=0)then
			self.statetimer=0
		end
	end
	
	if(self.state>=self.states.SPAWNMINIONS and self.state<self.states.RUNAWAY)then
		local i
		for i=1,8,1 do
			if(self.virmen[i]==nil or self.virmen[i].dead==true)then
				if(self.virmenrespawntime[i]~=nil)then
					self.virmenrespawntime[i]=self.virmenrespawntime[i]-elapsed*1000
					if(self.virmenrespawntime[i]<=0)then self.virmenrespawntime[i]=0 end				
				end
			end
		end
	
	
		self.nextminionspawnframecount=self.nextminionspawnframecount+1
		if(currenttime>=self.nextminionspawntime and self.nextminionspawnframecount>5)then			
			self.nextminionspawnframecount=0
			self.nextminionspawntime=currenttime+100
			local i
			local continue=true
			for i=1,8,1 do
				if(continue==true)then
					-- if(_TRAININGGROUNDS.game.keys.ctrl.current==true)then
						-- print(i, self.virmen[i])
						-- if(self.virmen[i]~=nil)then print(self.virmen[i].dead) end
					-- end
					if(self.virmen[i]==nil or self.virmen[i].dead==true)then
						if(self.virmenrespawntime[i]~=nil)then
							if(self.virmenrespawntime[i]<=0)then							
								self:NewVirmenAtIndex(i,currenttime)
								--self.virmenrespawntime[i]=5000
								self.virmenrespawntime[i]=10000
								continue=false
							end
						end
					end
				end
			end
		end
	end
	
	

	
end


function TRAININGGROUNDS_ScenarioController_Tutorial:NewVirmenAtIndex(i,currenttime)
	local angle=math.pi*2/8*(i-1)+math.pi
	--TODO: move to function; reuse function for replacements
	--TODO: change combat
	local virmen=TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen.new()
	--print("Calling setup on new virmen ",i)
	virmen:setup(self.environment);
	virmen.x=200*math.cos(angle)
	virmen.y=200*math.sin(angle)
	--print("NewVirmenAtIndex ",i,virmen.x,virmen.y)	
	virmen.combat=TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk.new();virmen.combat:setup(virmen)
	--virmen.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP/8)
	local buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new()
	buff:setup(virmen.combat,currenttime);	virmen.modelframe:SetAlpha(0)
	virmen:SetAdjustedFacing(angle+math.pi/2)
	--virmen.modelframe:SetFacing(0)
	virmen.z=500--+(i*50)
	--virmen.zspeed=i*50
	self.virmen[i]=virmen
	
	-- if(i==1) then 
		-- print("NewVirmenAtIndex")
		-- TRAININGGROUNDS_FrameVisibilityCheck(virmen.frame)
		-- print("Tag: ",virmen.frame.tag)
	-- end
end