TRAININGGROUNDS_FakePlayerCharacter_DemonHunter = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_DemonHunter:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)
	self:ApplyDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_DemonHunter:SetEquipmentInfo(raceid,sex)	
	self.equipment=TRAININGGROUNDS_Equipment.new()
	-- SOURCE: wowroleplaygear.com/2011/05/12/demon-hunter/
	
	self.equipment:EquipItemToKnownSlot(32235,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(6583,"WristSlot")
	self.equipment:EquipItemToKnownSlot(24757,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(67236,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(7189,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(32837,"MainHandSlot")
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		self.equipment:EquipItemToKnownSlot(32838,"SecondaryHandSlot")
		-- we don't have a suitable replacement for non-DW classes
	end
	
	if(sex~=0)then
		--print("FakePlayerCharacter_DemonHunter "..tostring(sex))
		self.equipment:EquipItemToKnownSlot(6523,"ChestSlot")
	end

	
	-- self.equipment:TryItem(32235)
	-- self.equipment:TryItem(6583)
	-- self.equipment:TryItem(24757)
	-- self.equipment:TryItem(67236)
	-- self.equipment:TryItem(7189)
	-- --self.equipment:TryItem(32837)
	-- --self.equipment:TryItem(32838)
	
	-- if(sex~=0)then
		-- self.equipment:TryItem(6523)
	-- end
end

function TRAININGGROUNDS_FakePlayerCharacter_DemonHunter:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.OneHandBasicAttack,
		FakePlayerCharacterTitleAnimations.OneHandFancyAttack,
		FakePlayerCharacterTitleAnimations.TankDodge
	}
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldFancyAttack)
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldSlashCombo)
		tinsert(sequences,FakePlayerCharacterTitleAnimations.TankBlock)		
	end
	return sequences
end