TRAININGGROUNDS_FakePlayerCharacter_Mage = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_Mage:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)
	self:ApplyDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_Mage:SetEquipmentInfo()
	self.equipment=TRAININGGROUNDS_Equipment.new()
	
	self.equipment:EquipItemToKnownSlot(119570,"ChestSlot")
	self.equipment:EquipItemToKnownSlot(119566,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(119567,"HandsSlot")
	self.equipment:EquipItemToKnownSlot(119568,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(119569,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(119571,"ShoulderSlot")
	self.equipment:EquipItemToKnownSlot(119572,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(119573,"WristSlot")	
	self.equipment:EquipItemToKnownSlot(119576,"MainHandSlot")	
	self.equipment:EquipItemToKnownSlot(119575,"BackSlot")	
	
	-- for i=119566,119573,1 do
		-- self.equipment:TryItem(i)	
	-- end	
end

function TRAININGGROUNDS_FakePlayerCharacter_Mage:Is2HOnTitleScreen()
	return true
end

function TRAININGGROUNDS_FakePlayerCharacter_Mage:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		FakePlayerCharacterTitleAnimations.UndirectedSpellcast,
		FakePlayerCharacterTitleAnimations.UndirectedSpellcast,
		FakePlayerCharacterTitleAnimations.StealthWalk,
		FakePlayerCharacterTitleAnimations.TwoHandBasicAttack2
	}
	return sequences
end