TRAININGGROUNDS_FakePlayerCharacter_Paladin = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_Paladin:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)
	self:ApplyDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_Paladin:SetEquipmentInfo()
	self.equipment=TRAININGGROUNDS_Equipment.new()
	
	self.equipment:EquipItemToKnownSlot(119613,"ChestSlot")
	self.equipment:EquipItemToKnownSlot(119614,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(119615,"HandsSlot")
	self.equipment:EquipItemToKnownSlot(119616,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(119617,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(119618,"ShoulderSlot")
	self.equipment:EquipItemToKnownSlot(119619,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(119620,"WristSlot")	
	self.equipment:EquipItemToKnownSlot(119639,"MainHandSlot")	
	self.equipment:EquipItemToKnownSlot(119640,"BackSlot")	
	
	-- for i=119613,119620,1 do
		-- self.equipment:TryItem(i)
	-- end	
end

function TRAININGGROUNDS_FakePlayerCharacter_Paladin:Is2HOnTitleScreen()
	return true
end


function TRAININGGROUNDS_FakePlayerCharacter_Paladin:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.TwoHandBasicAttack1,
		FakePlayerCharacterTitleAnimations.TwoHandBasicAttack1,
		FakePlayerCharacterTitleAnimations.TwoHandBasicAttack2,
		FakePlayerCharacterTitleAnimations.TwoHandBasicAttack2,
		FakePlayerCharacterTitleAnimations.TwoHandStab
		-- ,
		-- FakePlayerCharacterTitleAnimations.TankDodge,
		-- FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		-- FakePlayerCharacterTitleAnimations.UndirectedSpellcast
	}

	return sequences
end