TRAININGGROUNDS_FakePlayerCharacter_Warlock = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_Warlock:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)
	self:ApplyDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_Warlock:SetEquipmentInfo()
	self.equipment=TRAININGGROUNDS_Equipment.new()
	
	self.equipment:EquipItemToKnownSlot(119764,"ChestSlot")
	self.equipment:EquipItemToKnownSlot(119760,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(119761,"HandsSlot")
	self.equipment:EquipItemToKnownSlot(119762,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(119763,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(119765,"ShoulderSlot")
	self.equipment:EquipItemToKnownSlot(119766,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(119767,"WristSlot")	
	self.equipment:EquipItemToKnownSlot(119770,"MainHandSlot")	
	self.equipment:EquipItemToKnownSlot(119769,"BackSlot")
	
	-- for i=119760,119767,1 do
		-- self.equipment:TryItem(i)
	-- end	
end

function TRAININGGROUNDS_FakePlayerCharacter_Warlock:Is2HOnTitleScreen()
	return true
end

function TRAININGGROUNDS_FakePlayerCharacter_Warlock:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		FakePlayerCharacterTitleAnimations.UndirectedSpellcast,
		FakePlayerCharacterTitleAnimations.UndirectedSpellcast,
		FakePlayerCharacterTitleAnimations.UndirectedSpellcast,
		FakePlayerCharacterTitleAnimations.TwoHandStab
	}
	return sequences
end